function varargout = activity_map(varargin)
%ACTIVITY_MAP M-file for activity_map.fig
%      ACTIVITY_MAP, by itself, creates a new ACTIVITY_MAP or raises the existing
%      singleton*.
%
%      H = ACTIVITY_MAP returns the handle to a new ACTIVITY_MAP or the handle to
%      the existing singleton*.
%
%      ACTIVITY_MAP('Property','Value',...) creates a new ACTIVITY_MAP using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to activity_map_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      ACTIVITY_MAP('CALLBACK') and ACTIVITY_MAP('CALLBACK',hObject,...) call the
%      local function named CALLBACK in ACTIVITY_MAP.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help activity_map

% Last Modified by GUIDE v2.5 05-Aug-2010 17:21:31

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Dec. 1, 2011           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @activity_map_OpeningFcn, ...
                   'gui_OutputFcn',  @activity_map_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
   gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before activity_map is made visible.
function activity_map_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for activity_map
handles.output = hObject;

mainGuiInput = find(strcmp(varargin, 'BayesSpatialModelGui'));
handles.main = varargin{mainGuiInput+1};
data_view=getappdata(handles.main, 'data_view');

set(hObject,'Color',[0 0 0]);

handles.mri_struct = data_view.roi_struct;
handles.xdim = handles.mri_struct.hdr.dime.dim(2);
handles.ydim = handles.mri_struct.hdr.dime.dim(3);
handles.zdim = handles.mri_struct.hdr.dime.dim(4);
dims = [handles.xdim handles.ydim handles.zdim];

handles.pixdim = double(handles.mri_struct.hdr.dime.pixdim(2:4));
if any(handles.pixdim <= 0)
  handles.pixdim(find(handles.pixdim <= 0)) = 1;
end

%%%%Get origin position%%%%%
origin = abs(handles.mri_struct.hdr.hist.originator(1:3));
if isempty(origin) || all(origin == 0)		% according to SPM
    origin = (dims+1)/2;   
end;
origin = round(origin);
if any(origin > dims)				% simulate fMRI
  origin(find(origin > dims)) = dims(find(origin > dims));
end
if any(origin <= 0)
  origin(find(origin <= 0)) = 1;
end
handles.daspect = handles.pixdim ./ min(handles.pixdim);

handles.origin = origin;
handles.sag = origin(1);
handles.cor = origin(2);
handles.axi = origin(3);


handles.tal = [0 0 0];

%%%%%Set sagttial slider, change x direction%%%%
xslider_step(1) = 1/(handles.xdim);
xslider_step(2) = 1.00001/(handles.xdim);
set(handles.SagSlider, 'Min', 1, 'Max',handles.xdim, ...
    'SliderStep',xslider_step,'Value',handles.sag); %%Sagittal Y-Z, adjust x direction

%%%%%Set coronal slider, change y direction%%%%
yslider_step(1) = 1/(handles.ydim);
yslider_step(2) = 1.00001/(handles.ydim);
set(handles.CorSlider, 'Min', 1, 'Max',handles.ydim, ...
    'SliderStep',yslider_step,'Value',handles.cor); %%Coronal X-Z, adjust y direction

%%%%%Set Axial slider, change z direction%%%%
zslider_step(1) = 1/(handles.zdim);
zslider_step(2) = 1.00001/(handles.zdim);
set(handles.AxiSlider, 'Min', 1, 'Max',handles.zdim, ...
    'SliderStep',zslider_step,'Value',handles.axi); %%Axial X-Y, adjust z direction

%%%%%%Set up Contraxt%%%%%%%%%%
constslider_step(1) = 5/255;
constslider_step(2) = 5.00001/255;
set(handles.constrastSlider, 'Min',1,'Max',256,...
    'SliderStep', constslider_step, 'Value',1)
set(handles.contrastTx, 'String', '1');
handles.contrast = 1;

%%%%%set up axes plot parts%%%%%%%%%
set(handles.plotFrom, 'String', num2str(origin(3)-4));
set(handles.plotTo, 'String', num2str(origin(3)+4));
set(handles.plotStep, 'String', '2');

opcityStep(1)= 1/10;
opcityStep(2)= 1.00001/10;
set(handles.opcitySlider, 'Min',0,'Max',1,...
'SliderStep',opcityStep, 'Value',0.6);
set(handles.opcityTx, 'String', '0.6');

handles.opcity = 0.6;
handles.threshold = 0.15;
thresStep(1)= 1/20;
thresStep(2)= 1.00001/20;
set(handles.thresholdSlider, 'Min',0,'Max',1,...
'SliderStep',thresStep, 'Value',0.15);
set(handles.thresholdTx, 'String', '0.15');

handles.roi_voxel = get(handles.voxelLevel, 'Value');

%%%%%%%%Set up brightness%%%%%%%%%%
brightslider_step(1) = 1/20;
brightslider_step(2) = 1.00001/20;
set(handles.brightnessSlider, 'Min',-1,'Max',1,...
'SliderStep',brightslider_step, 'Value',0);
set(handles.brightnessTx, 'String', '0');
handles.brightness = 0;

%%%%%%%%Set up color%%%%%%%%%%
jet2=jet(64);
jet2(38:end, :)=[];
hot2=hot(64);
hot2(end-5:end, :)=[];
hot2(1:4, :)=[];
hot2(1:2:38, :)=[];
hot2(2:2:16, :)=[];
hot2=flipud(hot2);
hot3=[jet2; hot2];

handles.highcolor = hot3;%hsv(64);
handles.basecolor = gray(191);
handles.colorlevel = 256;

handles.intensityMax = max(handles.mri_struct.img(:));
minVal = min(data_view.roi_struct.img(:));
maxVal = max(data_view.roi_struct.img(:));
handles.scaledImg = scale_in(handles.mri_struct.img, minVal, maxVal, 190);%% scale image to 191 index grayimage, the hight 64 bit (in 256) will used for probability;

handles.bayesSpatial = data_view.bayesSpatial;
handles.regions = data_view.regions;
handles.contrastall = data_view.contrasts;
handles.contrasts = data_view.contrasts.matrix_contrasts(data_view.contrasts.var_index, :);
handles.region_struct = data_view.region_struct;
handles.total_region_name = data_view.total_region_name;

handles.designName = handles.contrastall.matrix_contrasts(:, 1);
handles.designVal = num2str(cell2mat(handles.contrastall.matrix_contrasts(data_view.contrasts.var_index, 2)));
set(handles.designMatrixName, 'string', handles.designName);
set(handles.designMatrixName, 'value', handles.contrastall.var_index);
set(handles.designMatrixVal, 'string', handles.designVal);

handles.pp = calc_fcprob(handles.bayesSpatial, handles.contrasts);
handles.region_ppmap = regional_pp_map(handles.pp,handles.regions,handles.region_struct.img);
handles.voxel_ppmap = voxel_pp_map(handles.pp,handles.region_struct.img, handles.bayesSpatial.BrainLocs, handles.bayesSpatial.glocs);

if handles.roi_voxel==0
    thresholded_functmap = ( handles.region_ppmap>=0.15) .* handles.region_ppmap; %%%% Threshold based on region level
    handles.max_pp = max(handles.region_ppmap(:));
else
    thresholded_functmap = ( handles.voxel_ppmap>=0.15) .* handles.voxel_ppmap; %%%% Threshold based on voxel level 
    handles.max_pp = max(handles.voxel_ppmap(:));
end

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;

newColormap = [(gray(191));zeros(1, 3); handles.highcolor];%%index 192 is not used, just for seperate the base and top colormap;
handles.color_map = newColormap;%colormap(gray(191));
handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, 0.6, newColormap);
handles.clim = [1, 191];

%%%%%%%%set up text string in the right bottom
set(handles.originalPos,'String',sprintf('%7.0d %7.0d %7.0d',origin(1),origin(2),origin(3)))
set(handles.crosshairPos,'String',sprintf('%7.0d %7.0d %7.0d',handles.sag,handles.cor, handles.axi));
set(handles.dimension,'String',sprintf('%7.0d %7.0d %7.0d',handles.xdim,handles.ydim,handles.zdim));
set(handles.crussorPos,'String',sprintf('%7.0d %7.0d %7.0d',handles.sag,handles.cor, handles.axi));

%%%%%%%%find region for the current crosshair position%
valId = cell2mat(handles.total_region_name(:, 1));
curIdVal = handles.region_struct.img(handles.sag, handles.cor, handles.axi);
curIdPos = find(ismember(valId, curIdVal)); 
if curIdPos
    set(handles.curInfo, 'ForegroundColor','g',...
        'FontSize', 10, 'HorizontalAlignment', 'left', 'String', ...
        sprintf('Current crosshair is located in the region: %s', ...
                handles.total_region_name{curIdPos, 2}));
else
    set(handles.curInfo,'String', '');
end

if handles.roi_voxel == 0
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));

    set(handles.cursorVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));
elseif handles.roi_voxel == 1;
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.voxel_ppmap(handles.sag, handles.cor, handles.axi)));
    
    set(handles.cursorVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));

end
colorMapStr=get(handles.colorMapPop, 'String');
colorMapVal = strmatch('Gray', colorMapStr);
handles.colorIndex = colorMapVal;
set(handles.colorMapPop, 'Value', colorMapVal);
set(handles.axesUnit, 'Value', 1); %%%default voxel


%%%%%%%%Set up Crosshair%%%%%%%%%%
set(handles.crosshairColor, 'User', [1 0 0]);
% RENDER INITIAL MRI IMAGES WITH CROSSHAIRS
% AXIAL SLICE

%%%%%%%%%%display Axial image and crosshair on it%%%%%%%
axes(handles.AxiAxes);

for cl = 1:3
    Saxial(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:, :, handles.axi))';
    Scor(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:,handles.cor,:))';
    Ssag(:, :, cl) = squeeze(handles.combinedImg(cl).combound(handles.sag,:,:))';
end
handles.axial_image = image(Saxial);
aspect = 1./handles.daspect;
% handles.axial_image = imagesc([0,handles.xdim],[0,handles.ydim],Saxial',handles.clim);
set(gca,'YDir','normal','XLimMode','manual','YLimMode','manual',...
    'ClimMode','manual','YColor',[0 0 0],'XColor',[0 0 0],'xtick',[],'ytick',[],'Tag','AxialAxes');
daspect(gca,aspect([1 2 3]));
set(handles.axial_image,'ButtonDownFcn','get_pos(''axi'');');
colormap(newColormap); %axis off;

pos_axi = [handles.sag, handles.cor];
crosshair = plot_crosshair(pos_axi, [], gca);
handles.axial_xline = crosshair.lx;
handles.axial_yline = crosshair.ly;

%%%%%%%%%%display CORONAL image and crosshair on it%%%%%%%
% CORONAL SLICE
axes(handles.CorAxes);
handles.coronal_image = image(Scor);
set(gca,'YDir','normal','XLimMode','manual','YLimMode','manual',...
    'ClimMode','manual','YColor',[0 0 0],'XColor',[0 0 0],'xtick',[],'ytick',[],'Tag','CoronalAxes')
daspect(gca,aspect([1 3 2]));
set(handles.coronal_image,'ButtonDownFcn','get_pos(''cor'');');

pos_cor = [handles.sag, handles.axi];
crosshair = plot_crosshair(pos_cor, [], gca);
handles.coronal_xline = crosshair.lx;
handles.coronal_yline = crosshair.ly;
colormap(newColormap); %axis off;

%%%%%%%%%%display SAGITTAL image and crosshair on it%%%%%%%
% SAGITTAL SLICE
axes(handles.SagAxes);
handles.sagittal_image = image(Ssag);
set(gca,'YDir','normal','XLimMode','manual','YLimMode','manual',...
    'ClimMode','manual','YColor',[0 0 0],'XColor',[0 0 0],'xtick',[],'ytick',[],'Tag','SagittalAxes')
daspect(gca,aspect([2 3 1]));
set(handles.sagittal_image,'ButtonDownFcn','get_pos(''sag'');');
colormap(newColormap); %axis off;

pos_sag = [handles.cor, handles.axi];
crosshair = plot_crosshair(pos_sag, [], gca);
handles.sagittal_xline = crosshair.lx;
handles.sagittal_yline = crosshair.ly;

%%%%%Update color map bar

% Generate colorbar labels
max_functmap_value = handles.max_pp;
incr_val=max_functmap_value/5;
int_part=floor(incr_val);
frac_part=incr_val-int_part;
incr=int_part + round(frac_part*10)/10;
handles.colorbar_labels = 0:incr:max_functmap_value+0.05;
handles.scaled_pp_labels = 1 +  ( 63 * handles.colorbar_labels/max_functmap_value);
axes(handles.cMap);
colorbar_plot(handles.cMap, handles.colorbar_labels, handles.scaled_pp_labels);

% Update handles structure
guidata(hObject, handles);
buttonmotion = @(hObject,eventdata)activity_map('figure1_WindowButtonMotionFcn',hObject,eventdata,guidata(hObject));
set(hObject, 'windowbuttonmotion', buttonmotion);

% --- Outputs from this function are returned to the command line.
function varargout = activity_map_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function SagSlider_Callback(hObject, eventdata, handles)
% hObject    handle to SagSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
%NewVal = get(hObject, 'Value');
handles.sag = round(get(hObject, 'Value'));
%handles.sag_mm = (handles.sag-handles.origin(1))*handles.pixdim(1);
axes(handles.SagAxes);

for cl = 1:3
    Ssag(:, :, cl) = squeeze(handles.combinedImg(cl).combound(handles.sag, :, :))';
end
set(handles.sagittal_image,'CData',Ssag);

set(handles.axial_yline,'Xdata',[handles.sag handles.sag]);
set(handles.coronal_yline,'Xdata',[handles.sag handles.sag]);

coordindex = get(handles.axesUnit,'Value');
if coordindex == 2,
    sag = (handles.sag-handles.origin(1))*handles.pixdim(1);
    cor = (handles.cor-handles.origin(2))*handles.pixdim(2);
    axi = (handles.axi-handles.origin(3))*handles.pixdim(3);    
    set(handles.crosshairPos,'String',sprintf('%7.1f %7.1f %7.1f',sag,cor,axi));
else 
    set(handles.crosshairPos,'String',sprintf('%7.0d %7.0d %7.0d',handles.sag,handles.cor, handles.axi));
end
if handles.roi_voxel == 0
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));
elseif handles.roi_voxel == 1;
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.voxel_ppmap(handles.sag, handles.cor, handles.axi)));
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function SagSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SagSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function CorSlider_Callback(hObject, eventdata, handles)
% hObject    handle to CorSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.cor = round(get(hObject, 'Value'));
%handles.cor_mm = (handles.cor-handles.origin(2))*handles.pixdim(2);
axes(handles.CorAxes);

for cl = 1:3
    Scor(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:,handles.cor,:))';
end        
set(handles.coronal_image,'CData',Scor);
set(handles.axial_xline,'Ydata',[handles.cor handles.cor]);
set(handles.sagittal_yline,'Xdata',[handles.cor handles.cor]);
coordindex = get(handles.axesUnit,'Value');
if coordindex == 2,
    sag = (handles.sag-handles.origin(1))*handles.pixdim(1);
    cor = (handles.cor-handles.origin(2))*handles.pixdim(2);
    axi = (handles.axi-handles.origin(3))*handles.pixdim(3);    
    set(handles.crosshairPos,'String',sprintf('%7.1f %7.1f %7.1f',sag,cor,axi));
else 
    set(handles.crosshairPos,'String',sprintf('%7.0d %7.0d %7.0d',handles.sag,handles.cor, handles.axi));
end

if handles.roi_voxel == 0
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));
elseif handles.roi_voxel == 1;
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.voxel_ppmap(handles.sag, handles.cor, handles.axi)));
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function CorSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to CorSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function AxiSlider_Callback(hObject, eventdata, handles)
% hObject    handle to AxiSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
handles.axi = round(get(hObject, 'Value'));
axes(handles.AxiAxes);
for cl = 1:3
    Saxi(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:, :, handles.axi))';
end
set(handles.axial_image,'CData',Saxi);
set(handles.coronal_xline,'Ydata',[handles.axi handles.axi]);
set(handles.sagittal_xline,'Ydata',[handles.axi handles.axi]);
coordindex = get(handles.axesUnit,'Value');
if coordindex == 2,
    sag = (handles.sag-handles.origin(1))*handles.pixdim(1);
    cor = (handles.cor-handles.origin(2))*handles.pixdim(2);
    axi = (handles.axi-handles.origin(3))*handles.pixdim(3);    
    set(handles.crosshairPos,'String',sprintf('%7.1f %7.1f %7.1f',sag,cor,axi));
else 
    set(handles.crosshairPos,'String',sprintf('%7.0d %7.0d %7.0d',handles.sag,handles.cor, handles.axi));
end
if handles.roi_voxel == 0
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));
elseif handles.roi_voxel == 1;
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.voxel_ppmap(handles.sag, handles.cor, handles.axi)));
end
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function AxiSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to AxiSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function originalPos_Callback(hObject, eventdata, handles)
% hObject    handle to originalPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of originalPos as text
%        str2double(get(hObject,'String')) returns contents of originalPos as a double
newOrigin = get(handles.originalPos, 'String');
handles.origin = str2num(newOrigin);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function originalPos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to originalPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    %set(hObject,'BackgroundColor','white');
    set(hObject,'BackgroundColor','black');
end
set(hObject,'BackgroundColor','black');


function crosshairVal_Callback(hObject, eventdata, handles)
% hObject    handle to crosshairVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of crosshairVal as text
%        str2double(get(hObject,'String')) returns contents of crosshairVal as a double


% --- Executes during object creation, after setting all properties.
function crosshairVal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to crosshairVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function crosshairPos_Callback(hObject, eventdata, handles)
% hObject    handle to crosshairPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of crosshairPos as text
%        str2double(get(hObject,'String')) returns contents of crosshairPos as a double


% --- Executes during object creation, after setting all properties.
function crosshairPos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to crosshairPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in getActive.
function getActive_Callback(hObject, eventdata, handles)
% hObject    handle to getActive (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in hideCrosshairs.
function hideCrosshairs_Callback(hObject, eventdata, handles)
% hObject    handle to hideCrosshairs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of hideCrosshairs
%set(handles.)
if get(handles.hideCrosshairs,'value')==1
    set(handles.hideCrosshairs, 'String', 'Show Crosshairs');
    set(handles.axial_xline, 'Visible', 'off');
    set(handles.axial_yline, 'Visible', 'off');

    set(handles.coronal_xline, 'Visible', 'off');
    set(handles.coronal_yline, 'Visible', 'off');
    
    set(handles.sagittal_xline, 'Visible', 'off');
    set(handles.sagittal_yline, 'Visible', 'off');
elseif get(handles.hideCrosshairs,'value')==0
    set(handles.hideCrosshairs, 'String', 'Hide Crosshairs');
    set(handles.axial_xline, 'Visible', 'on');
    set(handles.axial_yline, 'Visible', 'on');

    set(handles.coronal_xline, 'Visible', 'on');
    set(handles.coronal_yline, 'Visible', 'on');
    
    set(handles.sagittal_xline, 'Visible', 'on');
    set(handles.sagittal_yline, 'Visible', 'on');
end
guidata(hObject, handles);
    
% --- Executes on button press in axialPlot.
function axialPlot_Callback(hObject, eventdata, handles)
% hObject    handle to axialPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in QueryTD.
function QueryTD_Callback(hObject, eventdata, handles)
% hObject    handle to QueryTD (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

sag = (handles.sag-handles.origin(1))*handles.pixdim(1);
cor = (handles.cor-handles.origin(2))*handles.pixdim(2);
axi = (handles.axi-handles.origin(3))*handles.pixdim(3); 
outpoints = round(mni2tal([sag, cor, axi]));

set(handles.talairachText,'ForegroundColor','r',...
    'FontSize', 10, 'HorizontalAlignment', 'left', 'String',sprintf('Current Crosshair Talairach Coordinates: %s, %s, %s',num2str(outpoints(1)), num2str(outpoints(2)), num2str(outpoints(3))));
guidata(hObject, handles);

function dimension_Callback(hObject, eventdata, handles)
% hObject    handle to dimension (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of dimension as text
%        str2double(get(hObject,'String')) returns contents of dimension as a double


% --- Executes during object creation, after setting all properties.
function dimension_CreateFcn(hObject, eventdata, handles)
% hObject    handle to dimension (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    %set(hObject,'BackgroundColor','white');
    set(hObject,'BackgroundColor','blace');
end




function cursorVal_Callback(hObject, eventdata, handles)
% hObject    handle to cursorVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of cursorVal as text
%        str2double(get(hObject,'String')) returns contents of cursorVal as a double


% --- Executes during object creation, after setting all properties.
function cursorVal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to cursorVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function crussorPos_Callback(hObject, eventdata, handles)
% hObject    handle to crussorPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of crussorPos as text
%        str2double(get(hObject,'String')) returns contents of crussorPos as a double


% --- Executes during object creation, after setting all properties.
function crussorPos_CreateFcn(hObject, eventdata, handles)
% hObject    handle to crussorPos (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in crosshairColor.
function crosshairColor_Callback(hObject, eventdata, handles)
% hObject    handle to crosshairColor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
old_color = get(gcbo,'User');
new_color = uisetcolor(old_color);
set(handles.crosshairColor,'User',new_color);

set(handles.axial_xline, 'Color',new_color);
set(handles.axial_yline, 'Color',new_color);

set(handles.coronal_xline, 'Color',new_color);
set(handles.coronal_yline, 'Color',new_color);

set(handles.sagittal_xline, 'Color',new_color);
set(handles.sagittal_yline, 'Color',new_color);
    
  
% --- Executes on button press in reset.
function reset_Callback(hObject, eventdata, handles)
% hObject    handle to reset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


%%%%Get origin position%%%%%
dims = [handles.xdim handles.ydim handles.zdim];

origin = abs(handles.mri_struct.hdr.hist.originator(1:3));
if isempty(origin) || all(origin == 0)		% according to SPM
    origin = (dims+1)/2;   
end;
origin = round(origin);
if any(origin > dims)				% simulate fMRI
  origin(origin > dims) = dims(origin > dims);
end
if any(origin <= 0)
  origin(origin <= 0) = 1;
end

handles.origin = origin;
handles.sag = origin(1);
handles.cor = origin(2);
handles.axi = origin(3);

handles.tal = [0 0 0];

%%%%%Set sagttial slider, change x direction%%%%
set(handles.SagSlider, 'Value',handles.sag); %%Sagittal Y-Z, adjust x direction

%%%%%Set coronal slider, change y direction%%%%
set(handles.CorSlider, 'Value',handles.cor); %%Coronal X-Z, adjust y direction

%%%%%Set Axial slider, change z direction%%%%
set(handles.AxiSlider, 'Value',handles.axi); %%Axial X-Y, adjust z direction

%%%%%%Set up Contraxt%%%%%%%%%%
set(handles.constrastSlider, 'Value',1)
set(handles.contrastTx, 'String', '1');
handles.contrast = 1;

%%%%%set up axes plot parts%%%%%%%%%
set(handles.plotFrom, 'String', num2str(origin(3)-4));
set(handles.plotTo, 'String', num2str(origin(3)+4));
set(handles.plotStep, 'String', '2');

set(handles.opcitySlider, 'Value',0.6);
set(handles.opcityTx, 'String', '0.6');

handles.opcity = 0.6;
handles.threshold = 0.15;
set(handles.thresholdSlider, 'Value',0.15);
set(handles.thresholdTx, 'String', '0.15');

set(handles.voxelLevel, 'Value', 0);

%%%%%%%%Set up brightness%%%%%%%%%%
set(handles.brightnessSlider, 'Value',0);
set(handles.brightnessTx, 'String', '0');
handles.brightness = 0;

%%%%Top color will be hot
jet2=jet(64);
jet2(38:end, :)=[];
hot2=hot(64);
hot2(end-5:end, :)=[];
hot2(1:4, :)=[];
hot2(1:2:38, :)=[];
hot2(2:2:16, :)=[];
hot2=flipud(hot2);
hot3=[jet2; hot2];

%%%%%%%%%%%%Top color will be jet
handles.highcolor = hot3;
handles.basecolor = gray(191);
handles.colorlevel = 256;

handles.intensityMax = max(handles.mri_struct.img(:));
handles.roi_voxel=0;

% if handles.roi_voxel==0
    thresholded_functmap = ( handles.region_ppmap>=0.15) .* handles.region_ppmap; %%%% Threshold region level
% else
%     thresholded_functmap = ( handles.voxel_ppmap>=0.15) .* handles.voxel_ppmap; %%%% Threshold voxel level 
% end
set(handles.voxelLevel, 'String', 'Voxel Activity');
handles.max_pp = max(handles.region_ppmap(:));

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;

newColormap = [gray(191);zeros(1, 3); hot3];%%index 192 is not used, just for seperate the base and top colormap;
handles.color_map = newColormap;%colormap(gray(191));

handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, 0.6, newColormap);

handles.clim = [1, 191];

%%%%%%%%set up text string in the right bottom
set(handles.originalPos,'String',sprintf('%7.0d %7.0d %7.0d',origin(1),origin(2),origin(3)))
set(handles.crosshairPos,'String',sprintf('%7.0d %7.0d %7.0d',handles.sag,handles.cor, handles.axi));
set(handles.dimension,'String',sprintf('%7.0d %7.0d %7.0d',handles.xdim,handles.ydim,handles.zdim));
set(handles.crussorPos,'String',sprintf('%7.0d %7.0d %7.0d',handles.sag,handles.cor, handles.axi));
% set(handles.cursorVal,'String',handles.mri_struct.img(handles.sag,handles.cor, handles.axi));
% set(handles.crosshairVal,'String',handles.mri_struct.img(handles.sag,handles.cor, handles.axi));

if handles.roi_voxel == 0
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),...
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));

    set(handles.cursorVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor,handles.axi), 
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));
elseif handles.roi_voxel == 1;
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.voxel_ppmap(handles.sag, handles.cor, handles.axi)));
    
    set(handles.cursorVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));

end
colorMapStr=get(handles.colorMapPop, 'String');
colorMapVal = strmatch('Gray', colorMapStr);
handles.colorIndex = colorMapVal;
set(handles.colorMapPop, 'Value', colorMapVal);
set(handles.axesUnit, 'Value', 1); %%%default voxel


%%%%%%%%Set up Crosshair%%%%%%%%%%
set(handles.crosshairColor, 'User', [1 0 0]);
% RENDER INITIAL MRI IMAGES WITH CROSSHAIRS
% AXIAL SLICE

%%%%%%%%%%display Axial image and crosshair on it%%%%%%%

axes(handles.AxiAxes);
%Saxial = squeeze(handles.mri_struct.img(:,:,handles.axi));

for cl = 1:3
    Saxial(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:, :, handles.axi))';
    Scor(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:,handles.cor,:))';
    Ssag(:, :, cl) = squeeze(handles.combinedImg(cl).combound(handles.sag,:,:))';
end

set(handles.axial_image,'CData',Saxial);
set(handles.coronal_image,'CData',Scor);
set(handles.sagittal_image,'CData',Ssag);

set(handles.axial_yline,'Xdata',[handles.sag handles.sag]);
set(handles.axial_xline,'Ydata',[handles.cor handles.cor]);
        
set(handles.coronal_xline,'Ydata',[handles.axi handles.axi]);
set(handles.coronal_yline,'Xdata',[handles.sag handles.sag]);

set(handles.sagittal_xline,'Ydata',[handles.axi handles.axi]);
set(handles.sagittal_yline,'Xdata',[handles.cor handles.cor]);


% Generate colorbar labels
axes(handles.cMap);
max_functmap_value = handles.max_pp;
incr_val=max_functmap_value/5;
int_part=floor(incr_val);
frac_part=incr_val-int_part;
incr=int_part + round(frac_part*10)/10;
handles.colorbar_labels = 0:incr:max_functmap_value+0.05;
handles.scaled_pp_labels = 1 +  ( 63 * handles.colorbar_labels/max_functmap_value);
colorbar_plot(handles.cMap, handles.colorbar_labels, handles.scaled_pp_labels);

guidata(hObject, handles);



% --- Executes on selection change in colorMapPop.
function colorMapPop_Callback(hObject, eventdata, handles)
% hObject    handle to colorMapPop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns colorMapPop contents as cell array
%        contents{get(hObject,'Value')} returns selected item from colorMapPop
handles.colorIndex = get(hObject,'Value');
[handles.color_map, handles.combinedImg] = change_color_map(handles, handles.colorIndex, handles.clim);      

handles = change_Image(handles);

guidata(hObject, handles);     

% --- Executes during object creation, after setting all properties.
function colorMapPop_CreateFcn(hObject, eventdata, handles)
% hObject    handle to colorMapPop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in axesUnit.
function axesUnit_Callback(hObject, eventdata, handles)
% hObject    handle to axesUnit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns axesUnit contents as cell array
%        contents{get(hObject,'Value')} returns selected item from axesUnit
coordindex = get(hObject,'Value');
if coordindex == 1,
    sag = handles.sag;
    cor = handles.cor;
    axi = handles.axi;
    origin = sprintf('%7.0d %7.0d %7.0d',handles.origin(1),handles.origin(2),handles.origin(3));
    string = sprintf('%7.0d %7.0d %7.0d',sag,cor,axi);
elseif coordindex == 2,
    sag = (handles.sag-handles.origin(1))*handles.pixdim(1);
    cor = (handles.cor-handles.origin(2))*handles.pixdim(2);
    axi = (handles.axi-handles.origin(3))*handles.pixdim(3);    
    origin = sprintf('%7.1f %7.1f %7.1f',0,0,0);
    string = sprintf('%7.1f %7.1f %7.1f',sag,cor,axi);
elseif coordindex == 3,
    sag = handles.tal(1);
    cor = handles.tal(2);
    axi = handles.tal(3);
    origin = sprintf('%7.1f %7.1f %7.1f',0,0,0);
    string = sprintf('%7.1f %7.1f %7.1f',sag,cor,axi);
end
set(handles.crosshairPos,'String',string);
set(handles.originalPos,'String',origin);

    
% --- Executes during object creation, after setting all properties.
function axesUnit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axesUnit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes when figure1 is resized.
function figure1_ResizeFcn(~, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object deletion, before destroying properties.
function dimension_DeleteFcn(hObject, eventdata, handles)
% hObject    handle to dimension (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function CloseMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to CloseMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
                     ['Close ' get(handles.figure1,'Name') '...'],...
                     'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)


% --------------------------------------------------------------------
function PrintMenuItem_Callback(hObject, eventdata, handles)
% hObject    handle to PrintMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
printdlg(handles.figure1);


% --- Executes on mouse motion over figure - except title and menu.
function figure1_WindowButtonMotionFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

axi = get(handles.AxiAxes, 'pos');
cor = get(handles.CorAxes, 'pos');
sag = get(handles.SagAxes, 'pos');
curr = get(hObject, 'currentpoint');

if	curr(1) >= axi(1) && curr(1) <= axi(1)+axi(3) && ...
	curr(2) >= axi(2) && curr(2) <= axi(2)+axi(4)
  curr = get(handles.AxiAxes, 'current');
  sag = curr(1,1);
  cor = curr(1,2);
  axi = handles.axi;
elseif	curr(1) >= cor(1) && curr(1) <= cor(1)+cor(3) && ...
    curr(2) >= cor(2) && curr(2) <= cor(2)+cor(4)
  curr = get(handles.CorAxes, 'current');
  sag = curr(1,1);
  cor = handles.cor;
  axi = curr(1,2);
elseif	curr(1) >= sag(1) && curr(1) <= sag(1)+sag(3) && ...
    curr(2) >= sag(2) && curr(2) <= sag(2)+sag(4)
  curr = get(handles.SagAxes, 'current');
  sag = handles.sag;
  cor = curr(1,1);
  axi = curr(1,2);
else
  set(handles.crussorPos,'String',' ');
  set(handles.cursorVal,'String',' ');
  return;

end

sag = round(sag);
cor = round(cor);
axi = round(axi);

if sag < 1
   sag = 1;
elseif sag > handles.xdim
   sag = handles.xdim;
end

if cor < 1
   cor = 1;
elseif cor > handles.ydim
   cor = handles.ydim;
end

if axi < 1
   axi = 1;
elseif axi > handles.zdim
   axi = handles.zdim;
end
img = handles.mri_struct.img;

if handles.roi_voxel == 0
    ppval = handles.region_ppmap(sag, cor, axi);
elseif handles.roi_voxel == 1;
    ppval = handles.voxel_ppmap(sag, cor, axi);
end
        
set(handles.cursorVal,'String',sprintf('PP:%4.2f',ppval))

if get(handles.axesUnit,'value') == 2,
    sag = (sag-handles.origin(1))*handles.pixdim(1);
    cor = (cor-handles.origin(2))*handles.pixdim(2);
    axi = (axi-handles.origin(3))*handles.pixdim(3);
    string = sprintf('%7.1f %7.1f %7.1f',sag,cor,axi);
elseif get(handles.axesUnit,'value') == 3,
    sag = handles.tal(1);
    cor = handles.tal(2);
    axi = handles.tal(3);
    string = sprintf('%7.1f %7.1f %7.1f',sag,cor,axi);
else
    string = sprintf('%7.0d %7.0d %7.0d',sag,cor,axi);
end
set(handles.crussorPos,'String',string);

guidata(hObject, handles);


% --- Executes on slider movement.
function brightnessSlider_Callback(hObject, eventdata, handles)
% hObject    handle to brightnessSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.brightness = get(hObject, 'Value');
set(handles.brightnessTx, 'String', num2str(handles.brightness));
[handles.color_map, handles.combinedImg] = change_color_map(handles, handles.colorIndex, handles.clim);
handles = change_Image(handles);

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function brightnessSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to brightnessSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function constrastSlider_Callback(hObject, eventdata, handles)
% hObject    handle to constrastSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.contrast = round(get(hObject, 'Value'));
set(handles.contrastTx, 'String', num2str(handles.contrast));
[handles.color_map, handles.combinedImg] = change_color_map(handles, handles.colorIndex, handles.clim);
handles = change_Image(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function constrastSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to constrastSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function brightnessTx_Callback(hObject, eventdata, handles)
% hObject    handle to brightnessTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of brightnessTx as text
%        str2double(get(hObject,'String')) returns contents of brightnessTx as a double

handles.brightness = str2double(get(handles.brightnessTx, 'String'));
set(handles.brightnessSlider, 'Value', handles.brightness);
[handles.color_map, handles.combinedImg] = change_color_map(handles, handles.colorIndex, handles.clim);
handles = change_Image(handles);
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function brightnessTx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to brightnessTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function contrastTx_Callback(hObject, eventdata, handles)
% hObject    handle to contrastTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of contrastTx as text
%        str2double(get(hObject,'String')) returns contents of contrastTx as a double

handles.contrast = str2num(get(handles.contrastTx, 'String'));
set(handles.constrastSlider, 'Value', handles.contrast);
[handles.color_map, handles.combinedImg, ppmap] = change_color_map(handles, handles.colorIndex, handles.clim);
handles = change_Image(handles, ppmap);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function contrastTx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to contrastTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function thresholdSlider_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
threshold = get(hObject, 'Value');
set(handles.thresholdTx, 'String', num2str(threshold));
opacity = handles.opcity;%str2double(get(handles.opcityTx, 'String'));
handles.threshold = threshold;

if handles.roi_voxel==0
    thresholded_functmap = ( handles.region_ppmap>=threshold) .* handles.region_ppmap ; %%%% Threshold region level
else
    thresholded_functmap = ( handles.voxel_ppmap>=threshold) .* handles.voxel_ppmap ; %%%% Threshold voxel level 
end

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;

handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, opacity, handles.color_map);

handles = change_Image(handles);

guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function thresholdSlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdSlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function opcitySlider_Callback(hObject, eventdata, handles)
% hObject    handle to opcitySlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

opcity = get(hObject, 'Value');
set(handles.opcityTx, 'String', num2str(opcity));
threshold = handles.threshold; %str2double(get(handles.thresholdTx, 'String'));
handles.opcity = opcity;

if handles.roi_voxel==0
    thresholded_functmap = ( handles.region_ppmap>=threshold) .* handles.region_ppmap ; %%%% Threshold region level
else
    thresholded_functmap = ( handles.voxel_ppmap>=threshold) .* handles.voxel_ppmap ; %%%% Threshold voxel level 
end

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;

handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, opcity, handles.color_map);

handles = change_Image(handles);

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function opcitySlider_CreateFcn(hObject, eventdata, handles)
% hObject    handle to opcitySlider (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function thresholdTx_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdTx as text
%        str2double(get(hObject,'String')) returns contents of thresholdTx as a double
threshold = str2double(get(hObject, 'String'));
set(handles.thresholdSlider, 'Value', threshold);
opacity = handles.opcity;%str2double(get(handles.opcityTx, 'String'));
handles.threshold = threshold;
% opacity = str2double(get(handles.opcityTx, 'String'));

if handles.roi_voxel==0
    thresholded_functmap = ( handles.region_ppmap>=threshold) .* handles.region_ppmap ; %%%% Threshold region level
else
    thresholded_functmap = ( handles.voxel_ppmap>=threshold) .* handles.voxel_ppmap ; %%%% Threshold voxel level 
end

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;

handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, opacity, handles.color_map);

handles = change_Image(handles);

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function thresholdTx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function opcityTx_Callback(hObject, eventdata, handles)
% hObject    handle to opcityTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of opcityTx as text
%        str2double(get(hObject,'String')) returns contents of opcityTx as a double
opcity = str2double(get(hObject, 'String'));
set(handles.opcitySlider, 'Value', opcity);
% threshold = str2double(get(handles.thresholdTx, 'String'));
threshold = handles.threshold; %str2double(get(handles.thresholdTx, 'String'));
handles.opcity = opcity;

if handles.roi_voxel==0
    thresholded_functmap = ( handles.region_ppmap>=threshold) .* handles.region_ppmap ; %%%% Threshold region level
else
    thresholded_functmap = ( handles.voxel_ppmap>=threshold) .* handles.voxel_ppmap ; %%%% Threshold voxel level 
end

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;

handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, opcity, handles.Colormap);

handles = change_Image(handles);

guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function opcityTx_CreateFcn(hObject, eventdata, handles)
% hObject    handle to opcityTx (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function plotFrom_Callback(hObject, eventdata, handles)
% hObject    handle to plotFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plotFrom as text
%        str2double(get(hObject,'String')) returns contents of plotFrom as a double


% --- Executes during object creation, after setting all properties.
function plotFrom_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotFrom (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function plotTo_Callback(hObject, eventdata, handles)
% hObject    handle to plotTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plotTo as text
%        str2double(get(hObject,'String')) returns contents of plotTo as a double


% --- Executes during object creation, after setting all properties.
function plotTo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotTo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in axesPlot.
function axesPlot_Callback(hObject, eventdata, handles)
% hObject    handle to axesPlot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
plotFrom = round(str2double(get(handles.plotFrom, 'String')));
plotTo = round(str2double(get(handles.plotTo, 'String')));
plotStep = round(str2double(get(handles.plotStep, 'String')));
plotSpace = get(handles.plotSpace, 'String');
plotIdx = get(handles.plotSpace, 'Value');
orientation = plotSpace{plotIdx};
slices = plotFrom:plotStep:plotTo;
numslices=numel(slices)+1; % include colorbar as separate image 
numcols=floor(sqrt(numslices));
numrows=ceil(numslices/numcols);
% h0=figure();
for z=1:numslices-1
    for RGB_dim = 1:3        
        Saxial(:, :, RGB_dim) = squeeze(handles.combinedImg(RGB_dim).combound(:, :, slices(z)))';
        Scor(:, :, RGB_dim) = squeeze(handles.combinedImg(RGB_dim).combound(:,slices(z),:))';
        Ssag(:, :, RGB_dim) = squeeze(handles.combinedImg(RGB_dim).combound(slices(z),:,:))';
    end
        
    switch lower(orientation(1:3))  % pick off first few letters of orientation
        case 'all'
            figure(101)
            subplot(numrows,numcols,z)
            image(Saxial);
            axis xy 
            title(['Axial, slice', num2str(slices(z))]);
            
            figure(102)
            subplot(numrows,numcols,z)
            image(Scor);
            axis xy 
            title(['Coronal, slice', num2str(slices(z))]);
            
            figure(103)
            subplot(numrows,numcols,z)
            image(Ssag);
            axis xy 
            title(['Sagittal, slice', num2str(slices(z))]);
        case 'axi'
            figure(101)
            subplot(numrows,numcols,z)
            image(Saxial);
            axis xy 
            title(['Axial, slice', num2str(slices(z))]);
        case 'cor'
            figure(102)
            subplot(numrows,numcols,z)
            image(Scor);
            axis xy 
            title(['Coronal, slice', num2str(slices(z))]);
        case 'sag'
            figure(103)
            subplot(numrows,numcols,z)
            image(Ssag);
            axis xy 
            title(['Sagittal, slice', num2str(slices(z))]);
        otherwise
          error('Unknown orientation')        
    end
end

if handles.roi_voxel==0
    max_functmap_value = max(handles.region_ppmap(:));
    name = 'Region-based Activity Map';
else
    max_functmap_value = max(handles.voxel_ppmap(:));
    name = 'Voxel-based Activity Map';
end
vec64=[64:-1:1]';
colormat=repmat(vec64,1,10);
incr_val=max_functmap_value/5;
int_part=floor(incr_val);
frac_part=incr_val-floor(incr_val);
incr=int_part + round(frac_part*10)/10;
desired_colorbar_labels = 0:incr:max_functmap_value+0.05;
corresponding_values_on_1_to_64_scale = ...
    1 +  ( 63 * desired_colorbar_labels / max_functmap_value );
switch lower(orientation(1:3))  % pick off first few letters of orientation
    case 'all'
        figure(101)
        subplot(numrows,numcols,z+1)
        image(colormat);
        colormap(handles.highcolor);
        axis image 
        set(gca,'XTickLabel',[], 'YTick',corresponding_values_on_1_to_64_scale);
        set(gca,'YTickLabel',fliplr(desired_colorbar_labels),'YAxisLocation','right');
        set(gcf,'FileName', ['Axial, ', name]);

        figure(102)
        subplot(numrows,numcols,z+1)
        image(colormat);
        colormap(handles.highcolor);
        axis image
        set(gca,'XTickLabel',[], 'YTick',corresponding_values_on_1_to_64_scale);
        set(gca,'YTickLabel',fliplr(desired_colorbar_labels),'YAxisLocation','right');
        set(gcf,'FileName', ['Coronal, ', name]);

        figure(103)
        subplot(numrows,numcols,z+1)
        image(colormat);
        colormap(handles.highcolor);
        axis image  
        set(gca,'XTickLabel',[], 'YTick',corresponding_values_on_1_to_64_scale);
        set(gca,'YTickLabel',fliplr(desired_colorbar_labels),'YAxisLocation','right');
        set(gcf,'FileName', ['Sagittal, ', name]);
    case 'axi'
        figure(101)
        subplot(numrows,numcols,z+1)
        image(colormat);
        colormap(handles.highcolor);
        axis image 
        set(gca,'XTickLabel',[], 'YTick',corresponding_values_on_1_to_64_scale);
        set(gca,'YTickLabel',fliplr(desired_colorbar_labels),'YAxisLocation','right');
        set(gcf,'FileName', ['Axial, ', name]);
    case 'cor'
        figure(102)
        subplot(numrows,numcols,z+1)
        image(colormat);
        colormap(handles.highcolor);
        axis image
        set(gca,'XTickLabel',[], 'YTick',corresponding_values_on_1_to_64_scale);
        set(gca,'YTickLabel',fliplr(desired_colorbar_labels),'YAxisLocation','right');
        set(gcf,'FileName', ['Coronal, ', name]);
    case 'sag'
        figure(103)
        subplot(numrows,numcols,z+1)
        image(colormat);
        colormap(handles.highcolor);
        axis image
        set(gca,'XTickLabel',[], 'YTick',corresponding_values_on_1_to_64_scale);
        set(gca,'YTickLabel',fliplr(desired_colorbar_labels),'YAxisLocation','right');
        set(gcf,'FileName', ['Sagittal, ', name]);
end
% Generate colorbar labels


        

function plotStep_Callback(hObject, eventdata, handles)
% hObject    handle to plotStep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plotStep as text
%        str2double(get(hObject,'String')) returns contents of plotStep as a double


% --- Executes during object creation, after setting all properties.
function plotStep_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotStep (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in plotSpace.
function plotSpace_Callback(hObject, eventdata, handles)
% hObject    handle to plotSpace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns plotSpace contents as cell array
%        contents{get(hObject,'Value')} returns selected item from plotSpace


% --- Executes during object creation, after setting all properties.
function plotSpace_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotSpace (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in voxelLevel.
function voxelLevel_Callback(hObject, eventdata, handles)
% hObject    handle to voxelLevel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of voxelLevel
handles.roi_voxel = get(hObject, 'Value');
threshod = handles.threshold; %str2double(get(handles.thresholdTx, 'String'));
if handles.roi_voxel == 0
    set(handles.voxelLevel, 'String', 'Voxel Activity');
    thresholded_functmap = ( handles.region_ppmap>=threshod) .* handles.region_ppmap; %%%% Threshold region level
    handles.max_pp = max(handles.region_ppmap(:));
elseif handles.roi_voxel == 1
    set(handles.voxelLevel, 'String', 'Regional Activity');
    thresholded_functmap = ( handles.voxel_ppmap>=threshod) .* handles.voxel_ppmap; %%%% Threshold voxel level 
    handles.max_pp = max(handles.voxel_ppmap(:));
end

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;


handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, handles.opcity, handles.color_map);

max_functmap_value = handles.max_pp;
incr_val=max_functmap_value/5;
int_part=floor(incr_val);
frac_part=incr_val-int_part;
incr=int_part + round(frac_part*10)/10;
handles.colorbar_labels = 0:incr:max_functmap_value+0.05;
handles.scaled_pp_labels = 1 +  ( 63 * handles.colorbar_labels/max_functmap_value);

handles = change_Image(handles);

guidata(hObject, handles);

% --- Executes on button press in valprobBt.
function valprobBt_Callback(hObject, eventdata, handles)
% hObject    handle to valprobBt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in designMatrixName.
function designMatrixName_Callback(hObject, eventdata, handles)
% hObject    handle to designMatrixName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns designMatrixName contents as cell array
%        contents{get(hObject,'Value')} returns selected item from designMatrixName

var_index = get(handles.designMatrixName,'Value');
handles.designVal = num2str(cell2mat(handles.contrastall.matrix_contrasts(var_index, 2)));
set(handles.designMatrixVal, 'string', handles.designVal);
handles.contrasts = handles.contrastall.matrix_contrasts(var_index, :);
handles.pp = calc_fcprob(handles.bayesSpatial, handles.contrasts);
handles.region_ppmap = regional_pp_map(handles.pp,handles.regions,handles.region_struct.img);
handles.voxel_ppmap = voxel_pp_map(handles.pp,handles.region_struct.img, handles.bayesSpatial.BrainLocs, handles.bayesSpatial.glocs);

threshold = str2double(get(handles.thresholdTx, 'String'));
opacity = str2double(get(handles.opcityTx, 'String'));
if handles.roi_voxel==0
    thresholded_functmap = (handles.region_ppmap>=threshold) .* handles.region_ppmap; %%%% Threshold based on region level
    handles.max_pp = max(handles.region_ppmap(:));
else
    thresholded_functmap = (handles.voxel_ppmap>=threshold) .* handles.voxel_ppmap; %%%% Threshold based on voxel level 
    handles.max_pp = max(handles.voxel_ppmap(:));
end

handles.scaledRegPP = scale_in(thresholded_functmap, min(thresholded_functmap(:)), ...
                               max(thresholded_functmap(:)), 63)+192;%% scale region image to 64 index image;

handles.combinedImg = overlay_w_transparency(uint16(handles.scaledImg), uint16(handles.scaledRegPP), thresholded_functmap, opacity, handles.color_map);

max_functmap_value = handles.max_pp;
incr_val=max_functmap_value/5;
int_part=floor(incr_val);
frac_part=incr_val-int_part;
incr=int_part + round(frac_part*10)/10;
handles.colorbar_labels = 0:incr:max_functmap_value+0.05;
handles.scaled_pp_labels = 1 +  ( 63 * handles.colorbar_labels/max_functmap_value);

handles = change_Image(handles);

if handles.roi_voxel == 0
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.region_ppmap(handles.sag, handles.cor, handles.axi)));
elseif handles.roi_voxel == 1;
    set(handles.crosshairVal,'String',...
        sprintf('PP:%4.2f',...%handles.mri_struct.img(handles.sag, handles.cor, handles.axi),
                handles.voxel_ppmap(handles.sag, handles.cor, handles.axi)));
end

guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function designMatrixName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to designMatrixName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function designMatrixVal_Callback(hObject, eventdata, handles)
% hObject    handle to designMatrixVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of designMatrixVal as text
%        str2double(get(hObject,'String')) returns contents of designMatrixVal as a double


% --- Executes during object creation, after setting all properties.
function designMatrixVal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to designMatrixVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
