function handles = change_Image(handles)

% Internal funtion to change the image plot.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Dec. 1, 2011           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for cl = 1:3
    Saxial(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:, :, handles.axi))';
    Scor(:, :, cl) = squeeze(handles.combinedImg(cl).combound(:,handles.cor,:))';
    Ssag(:, :, cl) = squeeze(handles.combinedImg(cl).combound(handles.sag,:,:))';
end

set(handles.coronal_image,'CData',Scor);
set(handles.axial_xline,'Ydata',[handles.cor handles.cor]);
set(handles.sagittal_yline,'Xdata',[handles.cor handles.cor]);

set(handles.sagittal_image,'CData',Ssag);
set(handles.axial_yline,'Xdata',[handles.sag handles.sag]);
set(handles.coronal_yline,'Xdata',[handles.sag handles.sag]);

set(handles.axial_image,'CData',Saxial);
set(handles.coronal_xline,'Ydata',[handles.axi handles.axi]);
set(handles.sagittal_xline,'Ydata',[handles.axi handles.axi]);

set(handles.figure1, 'Colormap', handles.color_map);

axes(handles.cMap)
colorbar_plot(handles.cMap, handles.colorbar_labels, handles.scaled_pp_labels);