function colorbar_plot(f, colorbar_labels, corresponding_values_on_1_to_64_scale)
% Internal funtion to plot the colorbar.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Dec. 1, 2011           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
vec64=[64:-1:1]';
image(vec64);

%%%%Top color will be hot
jet2=jet(64);
jet2(38:end, :)=[];
hot2=hot(64);
hot2(end-5:end, :)=[];
hot2(1:4, :)=[];
hot2(1:2:38, :)=[];
hot2(2:2:16, :)=[];
hot2=flipud(hot2);
hot3=[jet2; hot2];

colormap(hot3);

% Generate colorbar labels
set(f,'XLimMode','manual',...
    'YColor',[1 0 0],'XColor',[1 0 0],'XTickLabel',[],...
    'YTickLabel',fliplr(colorbar_labels),'YAxisLocation','right',...
    'YTick',corresponding_values_on_1_to_64_scale);