function roi_ppmap=regional_pp_map(pp,regions,anat_map)
% This function calculate the region level posterior probabilities 

% Input: 
%   pp = structure w/ results, from the simulation output
%   region = the list of regions selected for analysis
%   anat_map = anatomical map (aal, Brodmann - full path)
% Output: 
%   roi_ppmap= 3D matrix w/ regional pp values

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Last revision: Jan 25, 2010                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

G=size(regions,1);

roi_ppmap=zeros(size(anat_map));
for g=1:G
    % TODO: get find function from modified version
    locs = [];
    locs = find(ismember(anat_map, regions(g, :)));
    roi_ppmap(locs)=pp.regional(g);
end

