function voxel_ppmap=voxel_pp_map(pp, anat_map, brain_locs, glocs)
% This function overlays voxel poster ior probabilities 
% over the anatomical brain
% Input: 
%   pp = structure w/ results, from the simulation output
%   anat_map = anatomical map (aal, Brodmann - full path)
% Output: 
%   voxel_ppmap= 3D matrix w/ voxel pp values

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Modified by: Lijun Zhang, Ph.D                   %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Last revision: Jan 25, 2010                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 


G=size(pp.regional,1);  % to get how many regions were analyzed; another way: read in regions list
gray_voxs=[];
for g=1:G
    gray_voxs=[gray_voxs, glocs(g).roi];
end

% Following depends on the contrast
% ----------------- Patients versus Controls ------------------------------
voxel_ppmap=zeros(size(anat_map));
voxel_ppmap(brain_locs(gray_voxs))=pp.voxel;


