function varargout = BayesSpatialModelGui(varargin)
% BAYESSPATIALMODELGUI M-file for BayesSpatialModelGui.fig
%      BAYESSPATIALMODELGUI, by itself, creates a new BAYESSPATIALMODELGUI or raises the existing
%      singleton*.
%
%      H = BAYESSPATIALMODELGUI returns the handle to a new BAYESSPATIALMODELGUI or the handle to
%      the existing singleton*.
%
%      BAYESSPATIALMODELGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BAYESSPATIALMODELGUI.M with the given input arguments.
%
%      BAYESSPATIALMODELGUI('Property','Value',...) creates a new BAYESSPATIALMODELGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before BayesSpatialModelGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to BayesSpatialModelGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help BayesSpatialModelGui

% Last Modified by GUIDE v2.5 06-Dec-2010 15:49:17
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Dec. 1, 2011           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @BayesSpatialModelGui_OpeningFcn, ...
                   'gui_OutputFcn',  @BayesSpatialModelGui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
% TODO: y - title = 'Spatial Bayesian Hierarchical Model (SBHM) v0.8'
% TODO: y - status bar should say 'Estimating Model Parameters <time left>'

% --- Executes just before BayesSpatialModelGui is made visible.
function BayesSpatialModelGui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to BayesSpatialModelGui (see VARARGIN)

% Choose default command line output for BayesSpatialModelGui
handles.output = hObject;
handles.combinedRegions = {};

% Declare global variables
global mode;
global rlm;
global brodmannMap;
global bayesSpatial;
global numSubjects;
global selectedRegionMap;
global AAL_template brodmann_template struct_template MNI_template; %set default template

% global regions;


bsmpath = which('bsm.m');
bsmpath = bsmpath(1:end-length('bsm.m'));

addpath(bsmpath);
addpath(fullfile(bsmpath, 'command'));
addpath(fullfile(bsmpath, 'Activity_Map'));
addpath(fullfile(bsmpath, 'function_connectivity'));
addpath(fullfile(bsmpath, 'NIFTI_20100106'));
%addpath(fullfile(bsmpath, 'plotting'));
addpath(fullfile(bsmpath, 'misc_tools'));

if ~exist('data', 'dir')
    mkdir('data');
end
if ~exist('results', 'dir')
    mkdir('results');
end

if ~exist('html', 'dir')
    mkdir('html');
end

rlm=load(fullfile('anatomical', 'RegionListboxMap.mat'));
brodmannMap = load(fullfile('anatomical','BrodmannRegionMap.mat'));
mode = 'single';
selectedRegionMap = 'analyze';
numSubjects = 0;

AAL_template = 'AAL_RPI_MNI_2mm.nii';
brodmann_template = 'brodmann_RPI_MNI_2mm.nii';
struct_template = 'struct_brain_2mm.mat';
MNI_template = 'MNI152_T1_2mm.nii';


tempColor=get(handles.uipanel2, 'BackgroundColor');
set(hObject,'Color', tempColor);
set(handles.a0, 'Enable', 'Off');
set(handles.b0, 'Enable', 'Off');
set(handles.c0, 'Enable', 'Off');
set(handles.d0, 'Enable', 'Off');
set(handles.e0, 'Enable', 'Off');
set(handles.f0, 'Enable', 'Off');
set(handles.r0, 'Visible', 'Off', 'Enable', 'Off');
set(handles.s0, 'Visible', 'Off', 'Enable', 'Off');
set(handles.textr0, 'Visible', 'Off');
set(handles.texts0, 'Visible', 'Off');
set(handles.addButton, 'Enable', 'Off');
set(handles.removeButton, 'Enable', 'Off');
%set(handles.importData, 'String', [{'Import Data'}; {'(Image Format)'}]);

set(handles.thinFactor, 'Enable', 'Off');
set(handles.iterations, 'Enable', 'Off');
set(handles.burnIn, 'Enable', 'Off');
set(handles.covWeight, 'Enable', 'Off');
set(handles.analyzeRegionsListbox, 'Enable', 'Off');
set(handles.brodmannRegionsListbox, 'Enable', 'Off');
set(handles.resetButton, 'Enable', 'Off');
set(handles.plotResultPanel, 'Visible', 'Off');%%added by Lj on Dec 14, 2009
set(handles.brodmannRadioBtn, 'Visible', 'Off');
set(handles.analyzeRadioBtn, 'Visible', 'Off');

handles.expdata = [];
handles.dataInfo = [];
handles.title_legend = [];
handles.datapath = [];

handles.singleRegions = [];
handles.combinedRegions = [];
handles.selectedRegionIDName = [];
handles.rowRgns = [];
handles.rowRgnsName = [];
handles.colRgns = [];
handles.colRgnsName = [];
handles.selectedRegions = 0;
handles.totalRegions = [];
guidata(hObject, handles);

% UIWAIT makes BayesSpatialModelGui wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = BayesSpatialModelGui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in browseButton.
function browseButton_Callback(hObject, eventdata, handles)
      global numSubjects;
      global selectedRegionMap;
      global AAL_template brodmann_template struct_template MNI_template;

            
      [filename, pathname] = uigetfile({'*.mat';'*.*'},'File Selector');  
      if isequal(filename,0)
          disp('User selected Cancel');
      else
%          set(handles.figure1,'Pointer','watch');
          % set(handles.analysisFile, 'String', strcat(pathname,filename));
          % load(strcat(pathname,filename));
          handles.datapath = strcat(pathname,filename);
          set(handles.analysisFile, 'String', handles.datapath);
          load(handles.datapath);          
          guidata(hObject, handles);
          %selectedRegionMap = RegionMapType;
          
          switch(selectedRegionMap)
              case 'analyze'                  
                  set(handles.analyzeRegionsListbox, 'Visible', 'On');
                  set(handles.brodmannRegionsListbox, 'Visible', 'Off');
                  set(handles.analyzeRadioBtn, 'Visible', 'On');
                  set(handles.brodmannRadioBtn, 'Visible', 'Off');
              case 'brodmann'                  
                  set(handles.analyzeRegionsListbox, 'Visible', 'Off');
                  set(handles.brodmannRegionsListbox, 'Visible', 'On');
                  set(handles.analyzeRadioBtn, 'Visible', 'Off');
                  set(handles.brodmannRadioBtn, 'Visible', 'On');
              otherwise
          end
          
          mY = mean(Y);
          
          temp = unique(X(:,1));
          for k = 1:length(temp)
            LenSub(k) = length(find(X(:,1)==temp(k)));
          end
          
          numSubjects = min(LenSub);
          
          %handles.numSubjects = size(find(X(:,2)), 1);
          mu0 = mean(mY);
          set(handles.contrastMean, 'String', mu0);
          set(handles.figure1,'Pointer','arrow');
          set(handles.contrastMean, 'Enable', 'On');
          set(handles.a0, 'Enable', 'On');
          set(handles.b0, 'Enable', 'On');
          set(handles.c0, 'Enable', 'On');
          set(handles.d0, 'Enable', 'On');
          
          set(handles.e0, 'Enable', 'On');
          set(handles.f0, 'Enable', 'On'); 

          set(handles.thinFactor, 'Enable', 'On');
          set(handles.iterations, 'Enable', 'On');
          set(handles.burnIn, 'Enable', 'On');
          set(handles.covWeight, 'Enable', 'On');
          set(handles.contrastsBtn, 'Enable', 'On'); 

          set(handles.dataTable, 'Enable', 'on');
          set(handles.combinedTable, 'Enable', 'on');

          set(handles.addButton, 'Enable', 'on');
          set(handles.removeButton, 'Enable', 'on');
%          disp(length(subj_nums));
%          set(handles.numSubjects, 'String', length(subj_nums));
%          drawnow();
      end
% hObject    handle to browseButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function analysisFile_Callback(hObject, eventdata, handles)
% hObject    handle to analysisFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of analysisFile as text
%        str2double(get(hObject,'String')) returns contents of analysisFile as a double


% --- Executes during object creation, after setting all properties.
function analysisFile_CreateFcn(hObject, eventdata, handles)
% hObject    handle to analysisFile (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function a0_Callback(hObject, eventdata, handles)
% hObject    handle to a0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of a0 as text
%        str2double(get(hObject,'String')) returns contents of a0 as a double


% --- Executes during object creation, after setting all properties.
function a0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to a0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function b0_Callback(hObject, eventdata, handles)
% hObject    handle to b0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of b0 as text
%        str2double(get(hObject,'String')) returns contents of b0 as a double


% --- Executes during object creation, after setting all properties.
function b0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to b0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function c0_Callback(hObject, eventdata, handles)
% hObject    handle to c0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c0 as text
%        str2double(get(hObject,'String')) returns contents of c0 as a double


% --- Executes during object creation, after setting all properties.
function c0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function d0_Callback(hObject, eventdata, handles)
% hObject    handle to d0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of d0 as text
%        str2double(get(hObject,'String')) returns contents of d0 as a double


% --- Executes during object creation, after setting all properties.
function d0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to d0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in calculateButton.
function calculateButton_Callback(hObject, eventdata, handles)
global bayesSpatial;
global selectedRegionMap;
global AAL_template brodmann_template struct_template MNI_template; %set default template

%analysis_data = get(handles.analysisFile, 'String');
analysis_data = handles.datapath;
iterations =  str2num(get(handles.iterations,'String'));  
burnIn =  str2num(get(handles.burnIn,'String'));  
thinFactor =  str2num(get(handles.thinFactor,'String'));  
covWeight =  str2num(get(handles.covWeight,'String'));  

monteCarloParams.iterations = iterations;
monteCarloParams.burnIn = burnIn;
monteCarloParams.thinFactor = thinFactor;
monteCarloParams.covWeight = covWeight;

a0 = str2num(get(handles.a0, 'String'));
b0 = str2num(get(handles.b0, 'String'));
c0 = str2num(get(handles.c0, 'String'));
d0 = str2num(get(handles.d0, 'String'));
e0 = str2num(get(handles.e0, 'String'));
f0 = str2num(get(handles.f0, 'String'));
r0 = str2num(get(handles.r0, 'String'));
s0 = str2num(get(handles.s0, 'String'));

gammaParams.a0 = a0;
gammaParams.b0 = b0;
gammaParams.c0 = c0;
gammaParams.d0 = d0;
gammaParams.e0 = e0;
gammaParams.f0 = f0;
gammaParams.r0 = r0;
gammaParams.s0 = s0;

singleRegionIds = handles.singleRegions;            
combinedRegionIds = handles.combinedRegions;
rowRgns = handles.rowRgns;     
if ~isempty(combinedRegionIds)
    combinedRegionIds(~logical(rowRgns))={nan}; %%make the empty table equal to -1           
end

temp1 = cell2mat(combinedRegionIds);
a = cell2mat(singleRegionIds);
temp2 = repmat(a, 1, 4);
regions = vertcat(temp2, temp1);
handles.totalRegions = regions;

%%%%%%
combinedId={};
combinedName={};
displayId = {};
displayName = {};
for ii=1:size(combinedRegionIds, 1)
    RgnId = combinedRegionIds(ii, :);
    RgnName = handles.rowRgnsName(ii, :);
    index = find(handles.rowRgns(ii, :));    
    tempId = RgnId(index);
    tempName = RgnName(index);   
    Id = [];
    Name = [];
    for jj = 1:length(index)
        Id = strcat(Id, num2str(tempId{jj}), ',');   
        Name = strcat(Name, tempName{jj}, ',');   
    end
    Id(end)=[];
    Name(end)=[];    
    combinedId{ii, 1} = Id;
    combinedName{ii, 1} = Name;
    displayId{ii, 1}=strcat('(', Id, ')');    
    displayName{ii, 1}=strcat('(', Name, ')');       
end
handles.totalRgnId =  vertcat(handles.singleRegions, displayId);
handles.totalRgnName = vertcat(handles.colRgnsName, displayName);

handles.combinedName = combinedName;
handles.combinedId = combinedId;

%%%%%%%%%%
bayesSpatial = BayesianSpatialModel(gammaParams, monteCarloParams, regions, analysis_data);
bayesSpatial.estimate();

post_sim1 = bayesSpatial.PostSim1;

for ii=1:size(post_sim1, 2)
     L = sqrt(size(post_sim1(ii).iGamma,1));
     Gamma1 = inv(reshape(median(post_sim1(ii).iGamma,2),L,L));
     R1 = diag(diag(Gamma1).^-0.5) * Gamma1 * diag(diag(Gamma1).^-0.5);
     %RThresh = R1 + 0./(R1 >= 0.1); 
     %RThresh=R1.*(R1 >= 0.1);
     %RThresh(RThresh==0)=NaN;
     
     conn_matrix{ii} = R1;%RThresh;
     %s = [sprintf('Regional Correlation Mat (R_%d)', ii), ' ', x_labs{ii}]; 
 end
 
handles.conn_matrix = conn_matrix;

%%%%functional connectivity structure%%%%%%
fc_para.conn_matrix = handles.conn_matrix;
fc_para.singleRegions = handles.singleRegions;
fc_para.combinedRegions = handles.combinedRegions;
fc_para.selectedRegionIDName = handles.selectedRegionIDName;

fc_para.rowRgnsName = handles.rowRgnsName;
fc_para.colRgnsName = handles.colRgnsName;

fc_para.selectedRegions = handles.selectedRegions;
fc_para.colRgns = handles.colRgns;
fc_para.rowRgns = handles.rowRgns;
fc_para.totalRegions = handles.totalRegions;

fc_para.totalRgnId =  handles.totalRgnId;
fc_para.totalRgnName = handles.totalRgnName;

fc_para.combinedName = handles.combinedName;
fc_para.combinedId = handles.combinedId;
fc_para.title_legend = handles.title_legend;
fc_para.dataInfo =  handles.dataInfo;

bayes.CombinedRegions = bayesSpatial.CombinedRegions;
bayes.monteCarloParams = bayesSpatial.monteCarloParams;
bayes.gammaParams = bayesSpatial.gammaParams;
bayes.BrainLocs = bayesSpatial.BrainLocs;
bayes.glocs = bayesSpatial.glocs;
bayes.PostSim1 = bayesSpatial.PostSim1;
bayes.PostSim2 = bayesSpatial.PostSim2;
bayes.NumStimulus = bayesSpatial.NumStimulus;
bayes.G = bayesSpatial.G;
bayes.Subject = bayesSpatial.Subject;

datapath = handles.datapath;

if ~exist('results', 'dir')
    mkdir('results');
end
save(fullfile('results','Estimation_Results.mat'), '-v7.3', 'bayes',...
              'selectedRegionMap', 'fc_para', 'datapath',...
              'AAL_template', 'brodmann_template', 'struct_template', 'MNI_template');

clear bayes fc_para
set(handles.plotResultPanel, 'Visible', 'On');%%added by Lj on Dec 14, 2009
set(handles.plotButton, 'Enable', 'On');
set(handles.resetButton, 'Enable', 'On');
set(handles.saveEstimation, 'Enable', 'On');
guidata(hObject, handles);

% hObject    handle to calculateButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in analyzeRegionsListbox.
function analyzeRegionsListbox_Callback(hObject, eventdata, handles)
% hObject    handle to analyzeRegionsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns analyzeRegionsListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from analyzeRegionsListbox


% --- Executes during object creation, after setting all properties.
function analyzeRegionsListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to analyzeRegionsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in addButton.
function addButton_Callback(hObject, eventdata, handles)
global selectedRegionMap;
if strcmp(selectedRegionMap, 'analyze') == 1
    index_selected = get(handles.analyzeRegionsListbox,'Value');
else
    index_selected = get(handles.brodmannRegionsListbox,'Value');
end    
global mode;
global rlm;
global brodmannMap;

global numSubjects;

if isempty(handles.selectedRegionIDName)
    totallRgns = [];
else
    totallRgns = cell2mat(handles.selectedRegionIDName(:, 1));
end
tempId=setdiff(index_selected, totallRgns);

overlap = ismember(index_selected, totallRgns);    
if any(overlap)
    warndlg('Regions that were already selected will be removed!', 'Warning');     
end  

lengthRegs = length(tempId);

if strcmp(mode, 'single')   % single selection mode    
    if lengthRegs %~isempty(tempId) 
        colRgns = handles.colRgns;
        %numSelected = selectedRegions + length(tempId);
        numSelected = handles.selectedRegions + lengthRegs;
        if numSelected > (numSubjects - 1)
            hh = regions_alert;
            switch(hh)
                case 'Cancel'
                    return;
                case 'OK'
                    set(handles.textr0, 'Visible', 'On');
                    set(handles.texts0, 'Visible', 'On');
                    set(handles.r0, 'Visible', 'On', 'Enable', 'On');
                    set(handles.s0, 'Visible', 'On', 'Enable', 'On');
            end
            %warndlg(sprintf('Based on your data and design matrix,you can include up to %s regions in your analysis. The total number of regions included must not exceed n_g-1, where n_g is the smallest subgroup sample size!', num2str(numSelected)), 'Warning'); 
            
            %return;
        end            
        %selectedRegions = numSelected;
        handles.selectedRegions = numSelected;
        colRgns = [colRgns tempId];
        if strcmp(selectedRegionMap, 'analyze') == 1
            colRgnsName = rlm.RegionListboxMap(colRgns, 3);
            set(handles.dataTable, 'Data', colRgnsName);
            singleRegionIds = rlm.RegionListboxMap(colRgns, 1);  %change here to rep new region id Aug 2012
            selectedRegionIDName = vertcat(handles.selectedRegionIDName, rlm.RegionListboxMap(tempId, :));
        else
            colRgnsName = brodmannMap.brodmann(colRgns, 2);
            set(handles.dataTable, 'Data', colRgnsName);
            singleRegionIds = brodmannMap.brodmann(colRgns, 1);  
            selectedRegionIDName = vertcat(handles.selectedRegionIDName, brodmannMap.brodmann(tempId, :));
        end
        handles.colRgns = colRgns;
        handles.colRgnsName = colRgnsName;
        handles.singleRegions = singleRegionIds;
        handles.selectedRegionIDName = selectedRegionIDName;
        %guidata(hObject, handles);
        
    end        
else   % combinded-region mode    
    if lengthRegs %~isempty(tempId) 
        if lengthRegs>4
            warndlg(sprintf('Combined regions should be less than 4!\n Please select again!'), 'Warning'); 
            return
        else
            numSelected = handles.selectedRegions + 1;%lengthRegs;
        end
        %rowRgns = [rowRgns, index_selected];
        %numSelected = size(rowRgns, 1) + length(index_selected);
        rowRgns = handles.rowRgns;
        rowRgnsName = handles.rowRgnsName;
        combinedRegionIds = handles.combinedRegions;
        if numSelected > (numSubjects - 1)
            hh = regions_alert;
            switch(hh)
                case 'Cancel'
                    return;
                case 'OK'
                    set(handles.textr0, 'Visible', 'On');
                    set(handles.texts0, 'Visible', 'On');
                    set(handles.r0, 'Visible', 'On', 'Enable', 'On');
                    set(handles.s0, 'Visible', 'On', 'Enable', 'On');
            end            
            %warndlg(sprintf('Based on your data and design matrix,you can include up to %s regions in your analysis. The total number of regions included must not exceed n_g-1, where n_g is the smallest subgroup sample size!', num2str(numSelected)), 'Warning'); 
            %return;
        end            
        handles.selectedRegions = numSelected;  
        tempRgn = zeros(1, 4);
        tempRgn(1:lengthRegs)=tempId;
        rowRgns = [rowRgns; tempRgn];
        if strcmp(selectedRegionMap, 'analyze') == 1                
            selectedRegionIDName = vertcat(handles.selectedRegionIDName, rlm.RegionListboxMap(tempId, :));
            a = cell(1, 4);
            b = cell(1, 4);
            a(1:lengthRegs) = rlm.RegionListboxMap(tempId, 3)';
            b(1:lengthRegs) = rlm.RegionListboxMap(tempId, 1)';%change here to rep new region id, Aug 2012
            rowRgnsName = vertcat(rowRgnsName, a);
            combinedRegionIds = vertcat(combinedRegionIds, b);               
            set(handles.combinedTable, 'Data', rowRgnsName);
        else
            selectedRegionIDName = vertcat(handles.selectedRegionIDName, brodmannMap.brodmann(tempId, :));
            a = cell(1, 4);
            b = cell(1, 4);
            a(1:length(tempId)) = brodmannMap.brodmann(tempId, 2)';
            b(1:length(tempId)) = brodmannMap.brodmann(tempId, 1)';
            rowRgnsName = vertcat(rowRgnsName, a);
            combinedRegionIds = vertcat(combinedRegionIds, b);            
            set(handles.combinedTable, 'Data', rowRgnsName);
        end            
        handles.combinedRegions = combinedRegionIds;
        handles.rowRgns = rowRgns;
        handles.rowRgnsName = rowRgnsName;
        handles.selectedRegionIDName = selectedRegionIDName;   
    end    
end
guidata(hObject, handles);
set(handles.calculateButton, 'Enable', 'On');

% hObject    handle to addButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in combinedRadioButton.
function combinedRadioButton_Callback(hObject, eventdata, handles)
% hObject    handle to combinedRadioButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of combinedRadioButton


% --- Executes when selected object is changed in selectionModePanel.
function selectionModePanel_SelectionChangeFcn(hObject, eventdata, handles)
    global mode;
    
    disp(get(eventdata.NewValue,'Tag'));
    switch get(eventdata.NewValue,'Tag') % Get Tag of selected object.
        case 'singleRadioButton'
            % Code for when radiobutton1 is selected.
            mode = 'single';
            set(handles.combinedTable, 'Visible', 'Off');
            set(handles.dataTable, 'Visible', 'On');
        case 'combinedRadioButton'
            % Code for when radiobutton2 is selected.
            mode = 'combined';
            set(handles.dataTable, 'Visible', 'Off');
            set(handles.combinedTable, 'Visible', 'On');
        % Continue with more cases as necessary.
        otherwise
            % Code for when there is no match.
    end
% hObject    handle to the selected object in selectionModePanel 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)



function thinFactor_Callback(hObject, eventdata, handles)
% hObject    handle to thinFactor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thinFactor as text
%        str2double(get(hObject,'String')) returns contents of thinFactor as a double


% --- Executes during object creation, after setting all properties.
function thinFactor_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thinFactor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function iterations_Callback(hObject, eventdata, handles)
% hObject    handle to iterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of iterations as text
%        str2double(get(hObject,'String')) returns contents of iterations as a double


% --- Executes during object creation, after setting all properties.
function iterations_CreateFcn(hObject, eventdata, handles)
% hObject    handle to iterations (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function burnIn_Callback(hObject, eventdata, handles)
% hObject    handle to burnIn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of burnIn as text
%        str2double(get(hObject,'String')) returns contents of burnIn as a double


% --- Executes during object creation, after setting all properties.
function burnIn_CreateFcn(hObject, eventdata, handles)
% hObject    handle to burnIn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function covWeight_Callback(hObject, eventdata, handles)
% hObject    handle to covWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of covWeight as text
%        str2double(get(hObject,'String')) returns contents of covWeight as a double


% --- Executes during object creation, after setting all properties.
function covWeight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to covWeight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function contrastMean_Callback(hObject, eventdata, handles)
% hObject    handle to contrastMean (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of contrastMean as text
%        str2double(get(hObject,'String')) returns contents of contrastMean as a double


% --- Executes during object creation, after setting all properties.
function contrastMean_CreateFcn(hObject, eventdata, handles)
% hObject    handle to contrastMean (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function numSubjects_Callback(hObject, eventdata, handles)
% hObject    handle to numSubjects (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of numSubjects as text
%        str2double(get(hObject,'String')) returns contents of numSubjects as a double


% --- Executes during object creation, after setting all properties.
function numSubjects_CreateFcn(hObject, eventdata, handles)
% hObject    handle to numSubjects (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in plotButton.
function plotButton_Callback(hObject, eventdata, handles)
global bayesSpatial;
contrasts = load(fullfile('results','matrix_contrasts'));
num_contrasts = size(contrasts.matrix_contrasts, 1);
btnType = get(handles.matFig, 'Value');

for index = 1 : num_contrasts
    contrast_cell = contrasts.matrix_contrasts(index, :);
    [cont_sim, pp, post_sim1] = calc_contrasts( bayesSpatial, contrast_cell);
    %[cont_sim, pp, post_sim1] = calc_contrasts( bayesSpatial.PostSim1, bayesSpatial.PostSim2, contrast_cell, bayesSpatial.NumStimulus, bayesSpatial.G, bayesSpatial.Subject );
    title = contrast_cell{1, 1};
    publishFunction(cont_sim, pp, post_sim1, char(title), handles.totalRgnId,handles.totalRgnName, btnType); 
end


set(handles.fcMenuItem, 'Enable', 'On');
set(handles.activation_map, 'Enable', 'On');
%plot_results_stmod2coc(bayesSpatial.ContSim, bayesSpatial.Bf, bayesSpatial.Pp, bayesSpatial.PostSim1, false)
% hObject    handle to plotButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Tools_1_Callback(hObject, eventdata, handles)
% hObject    handle to Tools_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function importData_Callback(hObject, eventdata, handles)
global numSubjects;

analysis_data_dlg('BayesSpatialModelGui', gcf);
filename = get(handles.analysisFile, 'String');
if filename
    load(filename);
    handles.datapath = filename;
    guidata(hObject, handles);
    
    mY = mean(Y); 
    mu0 = mean(mY);
    set(handles.contrastMean, 'String', mu0);
    set(handles.figure1,'Pointer','arrow');
    set(handles.contrastMean, 'Enable', 'On');

    temp = unique(X(:,1));
    for k = 1:length(temp)
    LenSub(k) = length(find(X(:,1)==temp(k)));
    end

    numSubjects = min(LenSub);
          
    set(handles.a0, 'Enable', 'On');
    set(handles.b0, 'Enable', 'On');
    set(handles.c0, 'Enable', 'On');
    set(handles.d0, 'Enable', 'On');
    set(handles.e0, 'Enable', 'On');
    set(handles.f0, 'Enable', 'On');
    
    set(handles.thinFactor, 'Enable', 'On');
    set(handles.iterations, 'Enable', 'On');
    set(handles.burnIn, 'Enable', 'On');
    set(handles.covWeight, 'Enable', 'On');
    set(handles.contrastsBtn, 'Enable', 'On');    
end

% hObject    handle to importData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function ViewDesignMatrix_Callback(hObject, eventdata, handles)
if isempty(handles.dataInfo)    
    filename = get(handles.analysisFile, 'String');
    if filename
        load(filename);   
        %Design_Matrix_Interface(C, X, gcf)    
        handles.datapath = filename;
        handles.expdata = X;
        handles.expdata_cov = X_Covariates;
        handles.dataInfo = C;
        handles.headInfo = headInfo;
        guidata(hObject, handles);   
        x_labs = design_matrix(gcf);
        handles.title_legend = x_labs;
        guidata(hObject, handles);
    else
        waitfor(warndlg({'Design Matrix does not exist!';'Please assign path to "Load saved data"!'}));
    end
else
    x_labs = design_matrix(gcf);
    handles.title_legend = x_labs;
    guidata(hObject, handles);
end

% hObject    handle to ViewDesignMatrix (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_5_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function Untitled_6_Callback(hObject, eventdata, handles)
filepath = which('bsm.m');
filepath = filepath(1:end-length('bsm.m'));
winopen(fullfile(filepath,'html','CBIS','cbis.htm'))
% hObject    handle to Untitled_6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
filepath = which('bsm.m');
filepath = filepath(1:end-length('bsm.m'));
winopen(fullfile(filepath, 'html','CBIS','data_file.htm'))
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: delete(hObject) closes the figure
disp('Exit BSMac, bye ...');
% check = exist('matrix_contrasts.mat');
% if check > 0
%     delete('matrix_contrasts.mat');
% end
delete(hObject);


% --- Executes on button press in contrastsBtn.
function contrastsBtn_Callback(hObject, eventdata, handles)
%global selectedRegionMap;
% filename = get(handles.analysisFile, 'String');
filename = handles.datapath;

if ~exist(filename)    
    [file, pathname] = uigetfile({'*.mat';'*.*'},'Selet the extracted data');  
    filename = fullfile(pathname, file);
end

if ~exist(filename)
    disp('User selected Cancel');
else
    load(filename);
    %Design_Matrix_Interface(C, X, gcf)    
    handles.expdata = X;
    handles.expdata_cov = X_Covariates;
    handles.dataInfo = C;
    handles.headInfo = headInfo;
    handles.RegionMapType = selectedRegionMap;
    guidata(hObject, handles);   
    x_labs = design_matrix(gcf);
    handles.title_legend = x_labs;
    guidata(hObject, handles); 
    set(handles.ViewDesignMatrix, 'Enable', 'on')
    
end


% --- Executes during object creation, after setting all properties.
function brodmannRegionsListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to brodmannRegionsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in analyzeRadioBtn.
function analyzeRadioBtn_Callback(hObject, eventdata, handles)
% hObject    handle to analyzeRadioBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of analyzeRadioBtn


% --- Executes on button press in brodmannRadioBtn.
function brodmannRadioBtn_Callback(hObject, eventdata, handles)
% hObject    handle to brodmannRadioBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of brodmannRadioBtn


% --- Executes on selection change in brodmannRegionsListbox.
function brodmannRegionsListbox_Callback(hObject, eventdata, handles)
% hObject    handle to brodmannRegionsListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns brodmannRegionsListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from brodmannRegionsListbox


% --------------------------------------------------------------------
function Untitled_8_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function fcMenuItem_Callback(hObject, eventdata, handles)
global selectedRegionMap;
global AAL_template brodmann_template struct_template MNI_template;
  

if isempty(handles.dataInfo)
    %filename = get(handles.analysisFile, 'String');
    filename = handles.datapath;
    if filename
        load(filename);
        handles.dataInfo = C;
        handles.expdata = X;
        
        guidata(hObject, handles); 
    else
        waitfor(warndlg({'Please assign path to "Load saved data"!'}));
    end
end

fcInput('BayesSpatialModelGui', gcf);   

% % fcInput('BayesSpatialModelGui', gcf, handles.singleRegions, handles.combinedRegions, C, selectedRegionMap);
% fcInput('BayesSpatialModelGui', gcf, handles.singleRegions, handles.combinedRegions);   


% hObject    handle to fcMenuItem (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in resetButton.
function resetButton_Callback(hObject, eventdata, handles)
set(handles.combinedTable, 'Data', []);
set(handles.dataTable, 'Data', []);
%global numSubjects;
global selectedRegionMap;

handles.singleRegions = [];
handles.combinedRegions = [];
handles.selectedRegionIDName = [];
handles.rowRgns = [];
handles.colRgns = [];
handles.rowRgnsName = [];
handles.selectedRegions = 0;

set(handles.plotButton, 'Enable', 'Off');
set(handles.calculateButton, 'Enable', 'Off');
set(handles.fcMenuItem, 'Enable', 'Off');
set(handles.activation_map, 'Enable', 'Off');

set(handles.a0, 'String', '0.1');
set(handles.b0, 'String', '0.005');
set(handles.c0, 'String', '0.1');
set(handles.d0, 'String', '0.01');
set(handles.e0, 'String', '0.1');
set(handles.f0, 'String', '0.05');
set(handles.r0, 'String', '0.1');
set(handles.s0, 'String', '0.05');

set(handles.textr0, 'Visible', 'Off');
set(handles.texts0, 'Visible', 'Off');
set(handles.r0, 'Visible', 'Off', 'Enable', 'Off');
set(handles.s0, 'Visible', 'Off', 'Enable', 'Off');

set(handles.thinFactor, 'String', '5');
set(handles.iterations, 'String', '2000');
set(handles.burnIn, 'String', '1000');
set(handles.covWeight, 'String', '0.5');

switch(selectedRegionMap)
    case 'analyze'
         set(handles.analyzeRegionsListbox, 'Enable', 'On');  
         set(handles.brodmannRadioBtn, 'Visible', 'Off');
         set(handles.analyzeRadioBtn, 'Visible', 'On');
         set(handles.brodmannRadioBtn, 'Visible', 'Off');
    case 'brodmann'
         set(handles.analyzeRegionsListbox, 'Enable', 'Off');  
         set(handles.brodmannRadioBtn, 'Visible', 'On');
         set(handles.analyzeRadioBtn, 'Visible', 'Off');
         set(handles.brodmannRadioBtn, 'Visible', 'On');
    otherwise
end

set(handles.resetButton, 'Enable', 'Off');
set(handles.plotResultPanel, 'Visible', 'Off');%%added by Lj on Dec 14, 2009

set(handles.plotResultPanel, 'Visible', 'Off');

guidata(hObject, handles); 
% hObject    handle to resetButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function activation_map_Callback(hObject, eventdata, handles)
% global regions;
global bayesSpatial; 
global selectedRegionMap;
global rlm;
global brodmannMap;
global AAL_template brodmann_template struct_template MNI_template; %set template


switch(selectedRegionMap)
    case 'analyze'
        RegionMap = load_nii(fullfile('anatomical', AAL_template));       
        RegionName = rlm.RegionListboxMap(:, [1,3]);%change here to rep new region id, Aug 2012
    case 'brodmann'
        RegionMap = load_nii(fullfile('anatomical',brodmann_template));     
        RegionName = brodmannMap.brodmann(:, 1:2);
    otherwise
end

contrasts = load(fullfile('results','matrix_contrasts'));

%pp_results = load('results/pp_results.mat');
% roi_ppmap = plot_regional_pp_map_toolbox(pp_results.pp, 0.2, regions, 'anatomical/ROI_MNI_V4.img', 0);

roi_struct=load_nii(fullfile('anatomical',MNI_template));

activity_view.roi_struct = roi_struct;
activity_view.region_struct = RegionMap;
activity_view.total_region_name = RegionName;
activity_view.bayesSpatial = bayesSpatial;
activity_view.regions =handles.totalRegions;
activity_view.contrasts = contrasts;
setappdata(gcf, 'data_view', activity_view);
warning off
activity_map('BayesSpatialModelGui', gcf);
warning on

% hObject    handle to activation_map (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in importData.
function importButton_Callback(hObject, eventdata, handles)
% hObject    handle to importData (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function importDataPath_Callback(hObject, eventdata, handles)
% hObject    handle to importDataPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of importDataPath as text
%        str2double(get(hObject,'String')) returns contents of importDataPath as a double


% --- Executes during object creation, after setting all properties.
function importDataPath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to importDataPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton10.
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
filepath = which('bsm.m');
filepath = filepath(1:end-length('bsm.m'));
winopen(fullfile(filepath, 'html','CBIS','data_file.htm'));


% --- Executes on button press in removeButton.
function removeButton_Callback(hObject, eventdata, handles)
% hObject    handle to removeButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global selectedRegionMap;
% if strcmp(selectedRegionMap, 'analyze') == 1
%     index_selected = get(handles.analyzeRegionsListbox,'Value');
% else
%     index_selected = get(handles.brodmannRegionsListbox,'Value');
% end    
global mode;
% global rlm;
% global brodmannMap;
global numSubjects;

totallRgns = cell2mat(handles.selectedRegionIDName(:, 1));

if strcmp(mode, 'single')  % single selection mode
    index = get(handles.dataTable, 'UserData');
    if ~isempty(index)  
        colRgns = handles.colRgns;
        colRgnsName = handles.colRgnsName;
        singleRegionIds = handles.singleRegions;
        index_selected = index(:, 1)';
        numSelected = handles.selectedRegions - length(index_selected);
        if numSelected > (numSubjects - 1)
            hh = regions_alert;
            switch(hh)
                case 'Cancel'
                    return;
                %case 'OK'
                %    set(handles.textr0, 'Enable', 'On');
                %    set(handles.texts0, 'Enable', 'On');
                %    set(handles.r0, 'Visible', 'On', 'Enable', 'On');
                %    set(handles.s0, 'Visible', 'On', 'Enable', 'On');
            end  
        else
            set(handles.textr0, 'Visible', 'Off');
            set(handles.texts0, 'Visible', 'Off');
            set(handles.r0, 'Visible', 'Off', 'Enable', 'Off');
            set(handles.s0, 'Visible', 'Off', 'Enable', 'Off');
        end
            
        removedId = colRgns(index_selected);
        orderId = find(ismember(totallRgns, removedId));
        handles.selectedRegionIDName(orderId, :)=[];
        colRgns(index_selected)=[];
        colRgnsName(index_selected)=[];
        singleRegionIds(index_selected) = [];
        handles.selectedRegions = numSelected;    
        set(handles.dataTable, 'Data', colRgnsName);
       
        handles.singleRegions = singleRegionIds;            
        handles.colRgns = colRgns;
        handles.colRgnsName = colRgnsName;
            %guidata(hObject, handles);       
    end
   
else  % combinded-region mode
    index = get(handles.combinedTable, 'UserData');
    if ~isempty(index)  
        rowRgns = handles.rowRgns;
        rowRgnsName = handles.rowRgnsName;
        combinedRegionIds = handles.combinedRegions; 
        %numSelected = handles.selectedRegions - size(index, 1);
        
        removedId = [];
        for k =1:size(index, 1)
            removedId(k) = rowRgns(index(k, 1), index(k, 2));
            %removedSubId(k) = sub2ind(size(rowRgns),index(k, 1), index(k, 2));
        end 
        removedSubId = sub2ind(size(rowRgns),index(:, 1), index(:, 2));
        orderId = find(ismember(totallRgns, removedId));
          
        rowRgns(removedSubId)=0;
        zeroId = find(~any(rowRgns, 2));
        numSelected = handles.selectedRegions - size(zeroId, 1);
        if numSelected > (numSubjects - 1)
            %regions_alert;
            hh = regions_alert;
            switch(hh)
                case 'Cancel'
                    return;
                %case 'OK'
                %    set(handles.textr0, 'Visible', 'On');
                %    set(handles.texts0, 'Visible', 'On');
                %    set(handles.r0, 'Visible', 'On','Enable', 'On');
                %    set(handles.s0, 'Visible', 'On', 'Enable', 'On');
            end  
            %warndlg(sprintf('Based on your data and design matrix,you can include up to %s regions in your analysis. The total number of regions included must not exceed n_g-1, where n_g is the smallest subgroup sample size!', num2str(numSelected)), 'Warning'); 
            %return;
        else
            set(handles.textr0, 'Visible', 'Off');
            set(handles.texts0, 'Visible', 'Off');
            set(handles.r0, 'Visible', 'Off', 'Enable', 'Off');
            set(handles.s0, 'Visible', 'Off', 'Enable', 'Off');
        end    
        handles.selectedRegionIDName(orderId, :) = [];
        handles.selectedRegions = numSelected; 
        rowRgns(zeroId, :)=[];
        rowRgnsName(removedSubId)={[]};
        rowRgnsName(zeroId, :)=[];
        combinedRegionIds(removedSubId)={[]};
        combinedRegionIds(zeroId, :)=[];
        set(handles.combinedTable, 'Data', rowRgnsName); 
                    % if strcmp(selectedRegionMap, 'analyze') == 1                  
        %     set(handles.combinedTable, 'Data', rowRgnsName);                             
        % else                           
        %     set(handles.combinedTable, 'Data', rowRgnsName);
        % end
        handles.combinedRegions = combinedRegionIds;
        handles.rowRgns = rowRgns;
        handles.rowRgnsName = rowRgnsName;            
            %guidata(hObject, handles);
       
    end    
end
guidata(hObject, handles);


function dataTable_CellSelectionCallback(hObject, eventdata, handles)
% hObject    handle to combinedTable (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) currently selecteds
% handles    structure with handles and user data (see GUIDATA)

sel = eventdata.Indices;
set(handles.dataTable, 'UserData', sel);



% --- Executes when selected cell(s) is changed in combinedTable.
function combinedTable_CellSelectionCallback(hObject, eventdata, handles)
% hObject    handle to combinedTable (see GCBO)
% eventdata  structure with the following fields (see UITABLE)
%	Indices: row and column indices of the cell(s) currently selecteds
% handles    structure with handles and user data (see GUIDATA)

sel = eventdata.Indices;
set(handles.combinedTable, 'UserData', sel);

% --- Executes during object creation, after setting all properties.
function regionTypePanel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to regionTypePanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in singleRadioButton.
function singleRadioButton_Callback(hObject, eventdata, handles)
% hObject    handle to singleRadioButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of singleRadioButton


% --- Executes during object creation, after setting all properties.
function selectionModePanel_CreateFcn(hObject, eventdata, handles)
% hObject    handle to selectionModePanel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --------------------------------------------------------------------
function Untitled_9_Callback(hObject, eventdata, handles)
% hObject    handle to plotButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over brodmannRadioBtn.
function brodmannRadioBtn_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to brodmannRadioBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over addButton.
function addButton_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to addButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes during object creation, after setting all properties.
function axes3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axes3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axes3
logoimage=imread('logo1.bmp');  
image(logoimage); 
axis off; 



function f0_Callback(hObject, eventdata, handles)
% hObject    handle to f0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of f0 as text
%        str2double(get(hObject,'String')) returns contents of f0 as a double


% --- Executes during object creation, after setting all properties.
function f0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to f0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function e0_Callback(hObject, eventdata, handles)
% hObject    handle to e0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of e0 as text
%        str2double(get(hObject,'String')) returns contents of e0 as a double


% --- Executes during object creation, after setting all properties.
function e0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to e0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in saveEstimation.
function saveEstimation_Callback(hObject, eventdata, handles)
% hObject    handle to saveEstimation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global bayesSpatial; 
global selectedRegionMap
[filename, pathname] = uiputfile(fullfile('results','Estimation_Results.mat'),'Save file name');  
if isequal(filename,0) || isequal(pathname,0)
   disp('The Estimation results have been saved into default folder under \results!')
else
    fc_para.conn_matrix = handles.conn_matrix;
    fc_para.singleRegions = handles.singleRegions;
    fc_para.combinedRegions = handles.combinedRegions;
    fc_para.selectedRegionIDName = handles.selectedRegionIDName;

    fc_para.rowRgnsName = handles.rowRgnsName;
    fc_para.colRgnsName = handles.colRgnsName;

    fc_para.selectedRegions = handles.selectedRegions;
    fc_para.colRgns = handles.colRgns;
    fc_para.rowRgns = handles.rowRgns;
    fc_para.totalRegions = handles.totalRegions;

    fc_para.totalRgnId =  handles.totalRgnId;
    fc_para.totalRgnName = handles.totalRgnName;

    fc_para.combinedName = handles.combinedName;
    fc_para.combinedId = handles.combinedId;
    fc_para.title_legend = handles.title_legend;
    fc_para.dataInfo =  handles.dataInfo;
    
    bayes.CombinedRegions = bayesSpatial.CombinedRegions;
    bayes.monteCarloParams = bayesSpatial.monteCarloParams;
    bayes.gammaParams = bayesSpatial.gammaParams;
    bayes.BrainLocs = bayesSpatial.BrainLocs;
    bayes.glocs = bayesSpatial.glocs;
    bayes.PostSim1 = bayesSpatial.PostSim1;
    bayes.PostSim2 = bayesSpatial.PostSim2;
    bayes.NumStimulus = bayesSpatial.NumStimulus;
    bayes.G = bayesSpatial.G;
    bayes.Subject = bayesSpatial.Subject;

    datapath = handles.datapath;
    disp(['The Estimation results will be saved at ',fullfile(pathname,filename)])
    save (fullfile(pathname, filename), 'bayes','selectedRegionMap', 'fc_para', 'datapath');
    clear bayes fc_para
end

% --- Executes on button press in loadEstimation.
function loadEstimation_Callback(hObject, eventdata, handles)
% hObject    handle to loadEstimation (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global bayesSpatial; 
global selectedRegionMap
global AAL_template brodmann_template struct_template MNI_template; %set default template

[filename, pathname] = uigetfile({'*.mat';'*.*'},'File Selector');  
if isequal(filename,0) || isequal(pathname,0)
  disp('User selected Cancel');
else
%          set(handles.figure1,'Pointer','watch');
    set(handles.estimationResults, 'String', fullfile(pathname,filename));
    load(fullfile(pathname,filename));
    handles.datapath = datapath;
    
    handles.conn_matrix = fc_para.conn_matrix;
    handles.singleRegions = fc_para.singleRegions;
    handles.combinedRegions = fc_para.combinedRegions;
    handles.selectedRegionIDName = fc_para.selectedRegionIDName;

    handles.rowRgnsName = fc_para.rowRgnsName;
    handles.colRgnsName = fc_para.colRgnsName;

    handles.selectedRegions = fc_para.selectedRegions;
    handles.colRgns = fc_para.colRgns;
    handles.rowRgns = fc_para.rowRgns;
    handles.totalRegions = fc_para.totalRegions;

    handles.totalRgnId =  fc_para.totalRgnId;
    handles.totalRgnName = fc_para.totalRgnName;

    handles.combinedName = fc_para.combinedName;
    handles.combinedId = fc_para.combinedId;
    handles.title_legend = fc_para.title_legend;
    handles.dataInfo =  fc_para.dataInfo;
        
    bayesSpatial.CombinedRegions = bayes.CombinedRegions;
    bayesSpatial.monteCarloParams = bayes.monteCarloParams;
    bayesSpatial.gammaParams = bayes.gammaParams;
    bayesSpatial.BrainLocs = bayes.BrainLocs;
    bayesSpatial.glocs = bayes.glocs;
    bayesSpatial.PostSim1 = bayes.PostSim1;
    bayesSpatial.PostSim2 = bayes.PostSim2;
    bayesSpatial.NumStimulus = bayes.NumStimulus;
    bayesSpatial.G = bayes.G;
    bayesSpatial.Subject = bayes.Subject;

        
%     set(handles.a0, 'Enable', 'On');
%     set(handles.b0, 'Enable', 'On');
%     set(handles.c0, 'Enable', 'On');
%     set(handles.d0, 'Enable', 'On');
%     set(handles.thinFactor, 'Enable', 'On');
%     set(handles.iterations, 'Enable', 'On');
%     set(handles.burnIn, 'Enable', 'On');
%     set(handles.covWeight, 'Enable', 'On');
    
    set(handles.a0, 'String', bayesSpatial.gammaParams.a0);
    set(handles.b0, 'String', bayesSpatial.gammaParams.b0);
    set(handles.c0, 'String', bayesSpatial.gammaParams.c0);
    set(handles.d0, 'String', bayesSpatial.gammaParams.d0);
    set(handles.e0, 'String', bayesSpatial.gammaParams.e0);
    set(handles.f0, 'String', bayesSpatial.gammaParams.f0);
    set(handles.r0, 'String', bayesSpatial.gammaParams.r0);
    set(handles.s0, 'String', bayesSpatial.gammaParams.s0);
    set(handles.thinFactor, 'String', bayesSpatial.monteCarloParams.thinFactor);
    set(handles.iterations, 'String', bayesSpatial.monteCarloParams.iterations);
    set(handles.burnIn, 'String', bayesSpatial.monteCarloParams.burnIn);
    set(handles.covWeight, 'String', bayesSpatial.monteCarloParams.covWeight);
    
    set(handles.plotResultPanel, 'Visible', 'On');%%added by Lj on Dec 14, 2009
    set(handles.plotButton, 'Enable', 'On');
  
    switch (selectedRegionMap)
        case 'analyze'
             set(handles.analyzeRegionsListbox, 'Enable', 'On');  
             set(handles.brodmannRadioBtn, 'Visible', 'Off');
             set(handles.analyzeRadioBtn, 'Visible', 'On');
             set(handles.brodmannRadioBtn, 'Visible', 'Off');
        case 'brodmann'
             set(handles.analyzeRegionsListbox, 'Enable', 'Off');  
             set(handles.brodmannRadioBtn, 'Visible', 'On');
             set(handles.analyzeRadioBtn, 'Visible', 'Off');
             set(handles.brodmannRadioBtn, 'Visible', 'On');
    end
    
    set(handles.dataTable, 'Data', handles.colRgnsName, 'Enable', 'off');
    set(handles.combinedTable, 'Data', handles.rowRgnsName, 'Enable', 'off');
    
    set(handles.addButton, 'Enable', 'Off');
    set(handles.removeButton, 'Enable', 'Off');
    set(handles.contrastsBtn, 'Enable', 'On'); 
    set(handles.saveEstimation, 'Enable', 'On');
    guidata(hObject, handles);
end


function estimationResults_Callback(hObject, eventdata, handles)
% hObject    handle to estimationResults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of estimationResults as text
%        str2double(get(hObject,'String')) returns contents of estimationResults as a double


% --- Executes during object creation, after setting all properties.
function estimationResults_CreateFcn(hObject, eventdata, handles)
% hObject    handle to estimationResults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton14.
function pushbutton14_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
filepath = which('bsm.m');
filepath = filepath(1:end-length('bsm.m'));
winopen(fullfile(filepath, 'html','CBIS','load_Estimated_Result_file.htm'));



function s0_Callback(hObject, eventdata, handles)
% hObject    handle to s0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of s0 as text
%        str2double(get(hObject,'String')) returns contents of s0 as a double


% --- Executes during object creation, after setting all properties.
function s0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to s0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function r0_Callback(hObject, eventdata, handles)
% hObject    handle to r0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of r0 as text
%        str2double(get(hObject,'String')) returns contents of r0 as a double


% --- Executes during object creation, after setting all properties.
function r0_CreateFcn(hObject, eventdata, handles)
% hObject    handle to r0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in saveRegion.
function saveRegion_Callback(hObject, eventdata, handles)
% hObject    handle to saveRegion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
SelRegions.colRgns = handles.colRgns;
SelRegions.colRgnsName = handles.colRgnsName;
SelRegions.singleRegionIds = handles.singleRegions;
SelRegions.selectedRegionIDName = handles.selectedRegionIDName;

SelRegions.rowRgns = handles.rowRgns;
SelRegions.rowRgnsName = handles.rowRgnsName;
SelRegions.combinedRegionIds = handles.combinedRegions;
SelRegions.numSelected = handles.selectedRegions;

[filename, pathname] = uiputfile(fullfile('results','SelectedRegions.mat'),'Save file name');  
save (fullfile(pathname, filename), 'SelRegions');
clear SelRegions;

% --- Executes on button press in loadRegion.
function loadRegion_Callback(hObject, eventdata, handles)
% hObject    handle to loadRegion (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[filename, pathname] = uigetfile({'*.mat';'*.*'},'File Selector');  
if isequal(filename,0) || isequal(pathname,0)
  disp('User selected Cancel');
else
    load(fullfile(pathname,filename));
    handles.selectedRegions = SelRegions.numSelected;
    handles.colRgns = SelRegions.colRgns;
    handles.colRgnsName = SelRegions.colRgnsName;
    handles.singleRegions = SelRegions.singleRegionIds;
    handles.selectedRegionIDName = SelRegions.selectedRegionIDName;
    set(handles.dataTable, 'Data', handles.colRgnsName);

    handles.combinedRegions = SelRegions.combinedRegionIds;
    handles.rowRgns = SelRegions.rowRgns;
    handles.rowRgnsName = SelRegions.rowRgnsName; 
    set(handles.combinedTable, 'Data', handles.rowRgnsName);
    guidata(hObject, handles);
end
set(handles.calculateButton, 'Enable', 'On');


% --------------------------------------------------------------------
function Untitled_7_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
About('BayesSpatialModelGui');
