function varargout = LegendGui(varargin)
% LEGENDGUI M-file for LegendGui.fig
%      LEGENDGUI, by itself, creates a new LEGENDGUI or raises the existing
%      singleton*.
%
%      H = LEGENDGUI returns the handle to a new LEGENDGUI or the handle to
%      the existing singleton*.
%
%      LEGENDGUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LEGENDGUI.M with the given input arguments.
%
%      LEGENDGUI('Property','Value',...) creates a new LEGENDGUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before LegendGui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to LegendGui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help LegendGui

% Last Modified by GUIDE v2.5 08-Mar-2009 17:29:59
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Dec. 1, 2011           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LegendGui_OpeningFcn, ...
                   'gui_OutputFcn',  @LegendGui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before LegendGui is made visible.
function LegendGui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to LegendGui (see VARARGIN)

% Choose default command line output for LegendGui
% handles.output = hObject;
handles.main = varargin{1};
groups =  varargin{2};
sessions = varargin{3};
stimuli = varargin{4};

no_groups=numel(groups);
no_sessions=numel(sessions);    
no_stimuli=numel(stimuli);
    
legend.groups = {1, 2};
legend.sessions = {1, 2};
legend.stimuli = {1};
handles.legend = legend;
handles.output = legend;

    %% Create the center panel
    centerPanelPos = [1 1 100 50];
    centerPanel = uipanel('bordertype','etchedin',...
        'Units','characters',...
        'Position', centerPanelPos,...
        'Parent',gcf);


    gY = 20;
    for g=1:no_groups;
        groupLabel(g) = uicontrol(gcf,'Style','text','Units','characters',...
                'Position',[1 gY-.5 10 2],...
                'String',strcat('Group ', num2str(g), ':'),...
                'Parent',centerPanel);
        groupText(g) = uicontrol(gcf,'Style','edit','Units','characters',...
                'Position', [15 gY 15 2],...
                'BackgroundColor', 'white',...
                'Parent', centerPanel ...
                );
        gY = gY - 3;
    end;

    stY = 20;
    for t=1:no_stimuli;
        stimulusLabel(t) = uicontrol(gcf,'Style','text','Units','characters',...
                'Position',[33 stY-.5 10 2],...
                'String',strcat('Stimulus ', num2str(t), ':'),...
                'Parent',centerPanel);
        stimulusText(t) = uicontrol(gcf,'Style','edit','Units','characters',...
                'Position', [43 stY 15 2],...
                'BackgroundColor', 'white',...
                'Parent', centerPanel ...
                );

        stY = stY - 3;
    end

    sY = 20;
    for s=1:no_sessions;
        
        sessionLabel(s) = uicontrol(gcf,'Style','text','Units','characters',...
                'Position',[60 sY-.5 10 2],...
                'String',strcat('Session ', num2str(s), ':'),...
                'Parent',centerPanel);
            
        sessionText(s) = uicontrol(gcf,'Style','edit','Units','characters',...
                'Position', [70 sY 15 2],...
                'BackgroundColor', 'white',...
                'Parent', centerPanel ...
                );
            
        sY = sY - 3;
    end;

    handles.sessions = sessionText;
    handles.groups = groupText;
    handles.stimuli = stimulusText;
    


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes LegendGui wait for user response (see UIRESUME)
uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = LegendGui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
% varargout{1} = get(handles.legend, 'String');

if handles.OutputFlag == 2
    for i=1:size(handles.groups, 2)
        legend.groups{i} = get(handles.groups(i), 'String');
    end
    for i=1:size(handles.sessions, 2)
        legend.sessions{i} = get(handles.sessions(i), 'String');
    end
    for i=1:size(handles.stimuli, 2)
        legend.stimuli{i} = get(handles.stimuli(i), 'String');
    end


    varargout{1} = legend;
    delete(hObject)
end

% --- Executes on button press in createLegendButton.
function createLegendButton_Callback(hObject, eventdata, handles)

handles.OutputFlag = 2;
guidata(hObject, handles)
uiresume
% uiresume(handles.main);
% close(handles.figure1);

% hObject    handle to createLegendButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


