function varargout = analysis_data_dlg(varargin)
% ANALYSIS_DATA_DLG M-file for analysis_data_dlg.fig
%      ANALYSIS_DATA_DLG, by itself, creates a new ANALYSIS_DATA_DLG or raises the existing
%      singleton*.
%
%      H = ANALYSIS_DATA_DLG returns the handle to a new ANALYSIS_DATA_DLG or the handle to
%      the existing singleton*.
%
%      ANALYSIS_DATA_DLG('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in ANALYSIS_DATA_DLG.M with the given input arguments.
%
%      ANALYSIS_DATA_DLG('Property','Value',...) creates a new ANALYSIS_DATA_DLG or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before analysis_data_dlg_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to analysis_data_dlg_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help analysis_data_dlg

% Last Modified by GUIDE v2.5 22-Aug-2012 14:00:24
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Dec. 1, 2011           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
% TODO - name should be 'Input Data'
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @analysis_data_dlg_OpeningFcn, ...
                   'gui_OutputFcn',  @analysis_data_dlg_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT



% --- Executes just before analysis_data_dlg is made visible.
function analysis_data_dlg_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to analysis_data_dlg (see VARARGIN)

%global isNifty;

global AAL_template brodmann_template struct_template MNI_template; %set default template
global selectedRegionMap;

AAL_template = 'AAL_RPI_MNI_2mm.nii';
brodmann_template = 'brodmann_RPI_MNI_2mm.nii';
struct_template = 'struct_brain_2mm.mat';
MNI_template = 'MNI152_T1_2mm.nii';

selectedRegionMap = 'analyze';

dontOpen = false;

mainGuiInput = find(strcmp(varargin, 'BayesSpatialModelGui'));
if (isempty(mainGuiInput)) || (length(varargin) <= mainGuiInput) || (~ishandle(varargin{mainGuiInput+1}))
    dontOpen = true;
else
    % Remember the handle, and adjust our position
    handles.main = varargin{mainGuiInput+1};    
    
    % Determine the position of the dialog - centered on the callback figure
    % if available, else, centered on the screen
    FigPos=get(0,'DefaultFigurePosition');
    OldUnits = get(hObject, 'Units');
    set(hObject, 'Units', 'pixels');
    OldPos = get(hObject,'Position');
    FigWidth = OldPos(3);
    FigHeight = OldPos(4);
    if isempty(gcbf)
        ScreenUnits=get(0,'Units');
        set(0,'Units','pixels');
        ScreenSize=get(0,'ScreenSize');
        set(0,'Units',ScreenUnits);

        FigPos(1)=1/2*(ScreenSize(3)-FigWidth);
        FigPos(2)=2/3*(ScreenSize(4)-FigHeight);
    else
        GCBFOldUnits = get(gcbf,'Units');
        set(gcbf,'Units','pixels');
        GCBFPos = get(gcbf,'Position');
        set(gcbf,'Units',GCBFOldUnits);
        FigPos(1:2) = [(GCBFPos(1) + GCBFPos(3) / 2) - FigWidth / 2, ...
                       (GCBFPos(2) + GCBFPos(4) / 2) - FigHeight / 2];
    end
    FigPos(3:4)=[FigWidth FigHeight];
    set(hObject, 'Position', FigPos);
    set(hObject, 'Units', OldUnits);    
    % Make the GUI modal
    set(gcf,'WindowStyle','modal')
end

% Choose default command line output for analysis_data_dlg
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);


if dontOpen
   disp('-----------------------------------------------------');
   disp('Improper input arguments. Pass a property value pair') 
   disp('whose name is "main_gui" and value is the handle')
   disp('to the main_gui figure, e.g:');
   disp('   x = main_gui()');
   disp('   changeme_dialog(''main_gui'', x)');
   disp('-----------------------------------------------------');
else
   uiwait(hObject);
end

% --- Outputs from this function are returned to the command line.
function varargout = analysis_data_dlg_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = [];


% --- Executes on button press in fileListBtn.
function fileListBtn_Callback(hObject, eventdata, handles)
  [filename, pathname] = uigetfile({'*.txt';'*.*'},'File Selector');  
  set(handles.fileListTxt, 'String', fullfile(pathname, filename));

% hObject    handle to fileListBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function fileListTxt_Callback(hObject, eventdata, handles)
% hObject    handle to fileListTxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of fileListTxt as text
%        str2double(get(hObject,'String')) returns contents of fileListTxt as a double


% --- Executes during object creation, after setting all properties.
function fileListTxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to fileListTxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in selectBtn.
function selectBtn_Callback(hObject, eventdata, handles)
data_info =  get(handles.fileListTxt, 'String');
fprintf('file %s\n', data_info);
save_path = get(handles.outputFileTxt, 'String');

global selectedRegionMap;
global AAL_template brodmann_template; %set default template

main = handles.main;
%if(ishandle(main))
    mainHandles = guidata(main);
    loadRawFile = mainHandles.importDataPath;
    set(loadRawFile, 'String', save_path);
    
    analysisFile = mainHandles.analysisFile;
    set(analysisFile, 'String', save_path);
    set(mainHandles.contrastsBtn, 'Enable', 'On');
%end

switch(selectedRegionMap)
    case 'analyze'
        RegionMap = load_nii(fullfile('anatomical', AAL_template)); 
        set(mainHandles.brodmannRadioBtn, 'Visible', 'Off');
        set(mainHandles.analyzeRadioBtn, 'Visible', 'On');
    case 'brodmann'
        RegionMap = load_nii(fullfile('anatomical',brodmann_template));
        set(mainHandles.brodmannRadioBtn, 'Visible', 'On');
        set(mainHandles.analyzeRadioBtn, 'Visible', 'Off');
    otherwise
end

fid=fopen(data_info);
if (fid < 0)
    error('could not open file %s\n', data_info);
end;
firstLine = fgetl(fid);

remain = firstLine;
str = [];
headInfo = [];
while true
    [str, firstLine] = strtok(firstLine);
    if isempty(str),  
        break;  
    end
    headInfo{end+1} = str;
end
   
tS = [];
for k = 1:length(headInfo) %headInfo{2}
    tS = [tS, ' %s'];
end
data= textscan(fid, tS);
fclose(fid);
      
if ~isequal(size(data,2), length(headInfo))
    errordlg({'Please check the input file format!';...
                '';...
               'The first line should be "Path  Name  Group  Session  Stimulus ...";';...
               'The file should at least has the first 5 columns.';...
               '';...
               'Using space to separate all the field!'},'File Error');
    return
end

if  size(data{1}, 1)<30  
    scan_data(data, RegionMap.img, headInfo, save_path);
else
    scan_data_lessspace(data, RegionMap.img, headInfo, save_path);
end

%design_matrix(data_info, regions_map);

delete(handles.figure1);
uiresume(handles.main);

% hObject    handle to selectBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when selected object is changed in uipanel1.
function uipanel1_SelectionChangeFcn(hObject, eventdata, handles)
    global AAL_template brodmann_template struct_template MNI_template;
    switch get(eventdata.NewValue,'Tag') % Get Tag of selected object.
        case 'mni1'
            AAL_template = 'AAL_RPI_MNI_1mm.nii';
            brodmann_template = 'brodmann_RPI_MNI_1mm.nii';
            struct_template = 'struct_brain_1mm.mat';
            MNI_template = 'MNI152_T1_1mm.nii'; 
        case 'mni2'
            AAL_template = 'AAL_RPI_MNI_2mm.nii';
            brodmann_template = 'brodmann_RPI_MNI_2mm.nii';
            struct_template = 'struct_brain_2mm.mat';
            MNI_template = 'MNI152_T1_2mm.nii';
        case 'mni3'
            AAL_template = 'AAL_RPI_MNI_3mm.nii';
            brodmann_template = 'brodmann_RPI_MNI_3mm.nii';
            struct_template = 'struct_brain_3mm.mat';
            MNI_template = 'MNI152_T1_3mm.nii';
        case 'mni4'
            AAL_template = 'AAL_RPI_MNI_4mm.nii';
            brodmann_template = 'brodmann_RPI_MNI_4mm.nii';
            struct_template = 'struct_brain_4mm.mat'; 
            MNI_template = 'MNI152_T1_4mm.nii';
        otherwise
            % Code for when there is no match.
    end
% hObject    handle to the selected object in uipanel1 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
[filename, pathname] = uiputfile(fullfile('data','analysis_data.mat'),'Save file name');  
set(handles.outputFileTxt, 'String', fullfile(pathname, filename));
set(handles.selectBtn, 'BackgroundColor', 'g');
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function outputFileTxt_Callback(hObject, eventdata, handles)
% hObject    handle to outputFileTxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of outputFileTxt as text
%        str2double(get(hObject,'String')) returns contents of outputFileTxt as a double


% --- Executes during object creation, after setting all properties.
function outputFileTxt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to outputFileTxt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
filepath = which('bsm.m');
filepath = filepath(1:end-length('bsm.m'));
winopen(fullfile(filepath,'html','CBIS','input_file_format.htm'));
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- If Enable == 'on', executes on mouse press in 5 pixel border.
% --- Otherwise, executes on mouse press in 5 pixel border or over fileListBtn.
function fileListBtn_ButtonDownFcn(hObject, eventdata, handles)
% hObject    handle to fileListBtn (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes when selected object is changed in uipanel3.
function uipanel3_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel3 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
main = guidata(handles.main);
global selectedRegionMap;
switch get(eventdata.NewValue,'Tag') % Get Tag of selected object.
    case 'aalBtn'
        % Code for when radiobutton1 is selected.
        selectedRegionMap = 'analyze';
        set(main.analyzeRegionsListbox, 'Visible', 'On');
        set(main.brodmannRegionsListbox, 'Visible', 'Off');
        
        set(main.analyzeRadioBtn, 'Visible', 'On');
        set(main.brodmannRadioBtn, 'Visible', 'Off');
    case 'brodmannBtn'
        % Code for when radiobutton2 is selected.
        selectedRegionMap = 'brodmann';
        set(main.analyzeRegionsListbox, 'Visible', 'Off');
        set(main.brodmannRegionsListbox, 'Visible', 'On');
        set(main.analyzeRadioBtn, 'Visible', 'Off');
        set(main.brodmannRadioBtn, 'Visible', 'On');        
    % Continue with more cases as necessary.
    otherwise
        % Code for when there is no match.
end


% --- Executes during object creation, after setting all properties.
function uipanel3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uipanel3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called
