function varargout = fcInput(varargin)
% FCINPUT M-file for fcInput.fig
%      FCINPUT by itself, creates a new FCINPUT or raises the
%      existing singleton*.
%
%      H = FCINPUT returns the handle to a new FCINPUT or the handle to
%      the existing singleton*.
%
%      FCINPUT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FCINPUT.M with the given input arguments.
%
%      FCINPUT('Property','Value',...) creates a new FCINPUT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fcInput_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fcInput_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help fcInput

% Last Modified by GUIDE v2.5 13-Jan-2010 12:14:04

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fcInput_OpeningFcn, ...
                   'gui_OutputFcn',  @fcInput_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before fcInput is made visible.
function fcInput_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fcInput (see VARARGIN)

% Choose default command line output for fcInput
handles.output = 'Yes';
mainGuiInput = find(strcmp(varargin, 'BayesSpatialModelGui'));
handles.main = varargin{mainGuiInput+1};
mainHandles = guidata(handles.main);
% handles.regions = mainHandles.singleRegions;
% handles.combinedRegions = mainHandles.combinedRegions;
global selectedRegionMap;
handles.selectedRegionMap = selectedRegionMap;

handles.regions = varargin{mainGuiInput+2};
handles.combinedRegions = varargin{mainGuiInput+3};
combined = {};
for ii=1:size(handles.combinedRegions, 1)
    s1 = handles.combinedRegions{ii, 1};
    s2 = handles.combinedRegions{ii, 2};
    s1 = num2str(s1);
    s2 = num2str(s2);
    combined{ii, 1} = strcat(s1, ', ', s2);
end
% data = varargin{mainGuiInput+4};
% handles.selectedRegionMap = varargin{mainGuiInput+5};

set(hObject,'Color',[0 0 0]);

if isempty(mainHandles.title_legend)
    data = mainHandles.dataInfo;
    groups=unique(data{3});
    no_groups=numel(groups);

    sessions=unique(data{4});
    no_sessions=numel(sessions);

    stimuli=unique(data{5});
    no_stimuli=numel(stimuli);

    x_labels={};        % labels for the design matrix display


    for g=1:no_groups;
        for s=1:no_sessions;
            for t=1:no_stimuli;
                x_labels{g, s, t}=strcat('(', groups(g), ',', sessions(s), ',', stimuli(t),')');
                pos=sub2ind([no_sessions no_groups no_stimuli], s, g, t); 
                labels(pos)=strcat('(', groups(g), ',', sessions(s), ',', stimuli(t),')');
            end
        end;
    end;
else
    labels = mainHandles.title_legend;
end

set(handles.groupSessionTaskListBox, 'String', labels);

%load('results/title_legend')

%set(handles.groupSessionTaskListBox, 'String', mainHandles.title_legend);

% Update handles structure


axes(handles.connectionMovie);
axis off;
axes(handles.connectionLegend); 
axis off;


guidata(hObject, handles);


set(handles.selectedRegionsListBox, 'String', vertcat(handles.regions, combined));
% Insert custom Title and Text if specified by the user
% Hint: when choosing keywords, be sure they are not easily confused 
% with existing figure properties.  See the output of set(figure) for
% a list of figure properties.
% if(nargin > 3)
%     for index = 1:2:(nargin-3),
%         if nargin-3==index, break, end
%         switch lower(varargin{index})
%          case 'title'
%           set(hObject, 'Name', varargin{index+1});
%          case 'string'
%           set(handles.text1, 'String', varargin{index+1});
%         end
%     end
% end

% Determine the position of the dialog - centered on the callback figure
% if available, else, centered on the screen
FigPos=get(0,'DefaultFigurePosition');
OldUnits = get(hObject, 'Units');
set(hObject, 'Units', 'pixels');
OldPos = get(hObject,'Position');
FigWidth = OldPos(3);
FigHeight = OldPos(4);
if isempty(gcbf)
    ScreenUnits=get(0,'Units');
    set(0,'Units','pixels');
    ScreenSize=get(0,'ScreenSize');
    set(0,'Units',ScreenUnits);

    FigPos(1)=1/2*(ScreenSize(3)-FigWidth);
    FigPos(2)=2/3*(ScreenSize(4)-FigHeight);
else
    GCBFOldUnits = get(gcbf,'Units');
    set(gcbf,'Units','pixels');
    GCBFPos = get(gcbf,'Position');
    set(gcbf,'Units',GCBFOldUnits);
    FigPos(1:2) = [(GCBFPos(1) + GCBFPos(3) / 2) - FigWidth / 2, ...
                   (GCBFPos(2) + GCBFPos(4) / 2) - FigHeight / 2];
end
FigPos(3:4)=[FigWidth FigHeight];
set(hObject, 'Position', FigPos);
set(hObject, 'Units', OldUnits);

% Make the GUI modal
%set(handles.figure1,'WindowStyle','modal')

% UIWAIT makes fcInput wait for user response (see UIRESUME)
%uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = fcInput_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
% varargout{1} = handles.output;

% The figure can be deleted now
% delete(handles.figure1);



% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.figure1);
else
    % The GUI is no longer waiting, just close it
    delete(handles.figure1);
end


% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check for "enter" or "escape"
if isequal(get(hObject,'CurrentKey'),'escape')
    % User said no by hitting escape
    handles.output = 'No';
    
    % Update handles structure
    guidata(hObject, handles);
    
    uiresume(handles.figure1);
end    
    
if isequal(get(hObject,'CurrentKey'),'return')
    uiresume(handles.figure1);
end    


% --- Executes on selection change in selectedRegionsListBox.
function selectedRegionsListBox_Callback(hObject, eventdata, handles)
% hObject    handle to selectedRegionsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns selectedRegionsListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from selectedRegionsListBox


% --- Executes during object creation, after setting all properties.
function selectedRegionsListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to selectedRegionsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% rlm=load('data/RegionListboxMap.mat');
% broadmannMap = load('data/BroadmannRegionMap.mat');
c = load('data/conn_matrix');
vals = get(handles.selectedRegionsListBox, 'String');
indices = get(handles.selectedRegionsListBox, 'Value');
regionVals = vals(indices);

% xx = rlm.RegionListboxMap(:, 2);
% for ii=1:size(xx)
%     s1 = num2str(xx{ii})
%     d{ii} = s1;
% end
% 
% 
% yy = broadmannMap.brodmann(:, 1);
% for ii=1:size(yy)
%     s1 = num2str(yy{ii})
%     e{ii} = s1;
% end



w = regexp(regionVals, ',','split');
jj = 1;
regionIds = {};

for ii=1:size(w)
        w1 = w(ii);
        if size(w1{1},2) > 1
             parsedRegions{jj} = [cell2mat(w1{1}(1))];
             parsedRegions{jj+1} = [cell2mat(w1{1}(2))];
             jj = jj + 1;
            temp = [str2num(cell2mat(w1{1}(1))) str2num(cell2mat(w1{1}(2)))];
            regionIds = horzcat(regionIds, temp);
        else
             regionIds = horzcat(regionIds, str2num(cell2mat(w1{1})));
            parsedRegions{jj} = [cell2mat(w1{1})];
        end
        jj = jj + 1;
end

if strcmp(handles.selectedRegionMap, 'analyze') == 1
    rlm=load('data/RegionListboxMap.mat');
    xx = rlm.RegionListboxMap(:, 2);
    for ii=1:size(xx, 1)
        s1 = num2str(xx{ii});
        d{ii} = s1;
    end
        
    [tf, loc] = ismember(parsedRegions, d);
    regionNames = rlm.RegionListboxMap([loc], 3);
    regionNames = regexprep(regionNames, '_','-');
    axes(handles.connectionMovie);
    connectivity_3D_SBHM(gca, c.conn_matrix, horzcat(handles.regions', handles.combinedRegions{:,1}), ...
        'anatomical/ROI_MNI_V4.img', regionNames, regionIds', '', 0.3, 'SBTM_2', 0.5, 5, 'Node to node connectivity');
    
else
    broadmannMap = load('data/BroadmannRegionMap.mat');
    yy = broadmannMap.brodmann(:, 1);
    for ii=1:size(yy)
        s1 = num2str(yy{ii});
        e{ii} = s1;
    end
    
    [tf, loc] = ismember(parsedRegions, e);
    regionNames = broadmannMap.brodmann([loc], 2);
    regionNames = regexprep(regionNames, '_','-');
    connectivity_3D_SBHM(gcf, c.conn_matrix, horzcat(handles.regions', handles.combinedRegions{:,1}), ...
        'anatomical/rbrodmann_2mm.img', regionNames, regionIds', '', 0.3, 'SBTM_2', 0.5, 5, 'Node to node connectivity');
end


%close(handles.figure1);
 % hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in groupSessionTaskListBox.
function groupSessionTaskListBox_Callback(hObject, eventdata, handles)
% hObject    handle to groupSessionTaskListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns groupSessionTaskListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from groupSessionTaskListBox


% --- Executes during object creation, after setting all properties.
function groupSessionTaskListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to groupSessionTaskListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function c_input_box_Callback(hObject, eventdata, handles)
% hObject    handle to c_input_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_input_box as text
%        str2double(get(hObject,'String')) returns contents of c_input_box as a double


% --- Executes during object creation, after setting all properties.
function c_input_box_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_input_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function brainPath_Callback(hObject, eventdata, handles)
% hObject    handle to brainPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of brainPath as text
%        str2double(get(hObject,'String')) returns contents of brainPath as a double


% --- Executes during object creation, after setting all properties.
function brainPath_CreateFcn(hObject, eventdata, handles)
% hObject    handle to brainPath (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in brainPathBrowse.
function brainPathBrowse_Callback(hObject, eventdata, handles)
% hObject    handle to brainPathBrowse (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on slider movement.
function connectionThres_Callback(hObject, eventdata, handles)
% hObject    handle to connectionThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function connectionThres_CreateFcn(hObject, eventdata, handles)
% hObject    handle to connectionThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function connectionVal_Callback(hObject, eventdata, handles)
% hObject    handle to connectionVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of connectionVal as text
%        str2double(get(hObject,'String')) returns contents of connectionVal as a double


% --- Executes during object creation, after setting all properties.
function connectionVal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to connectionVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function opacityThres_Callback(hObject, eventdata, handles)
% hObject    handle to opacityThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider


% --- Executes during object creation, after setting all properties.
function opacityThres_CreateFcn(hObject, eventdata, handles)
% hObject    handle to opacityThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function opacityVal_Callback(hObject, eventdata, handles)
% hObject    handle to opacityVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of opacityVal as text
%        str2double(get(hObject,'String')) returns contents of opacityVal as a double


% --- Executes during object creation, after setting all properties.
function opacityVal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to opacityVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


