%% Publish the figures to HTML

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Writen by: Gordana Derado, Ph.D, Emory Univ.     %
% Modified by: Lijun Zhang, Ph.D                   %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Jan 25, 2010           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 

function  publishFunction(cont_sim, pp, post_sim1, title, combinedRegions,RegNames, btnType)

    if btnType
        plot_contrasts_stmod2coc(cont_sim, pp, post_sim1, title, combinedRegions, RegNames, btnType);
    else
            % assign the values in the base workspace so the eval function will
        % be able to find the variables
        assignin('base', 'cont_sim', cont_sim);
        assignin('base', 'pp', pp);
        assignin('base', 'post_sim1', post_sim1);
        assignin('base', 'title', title);
        assignin('base', 'combinedRegions', combinedRegions);
        assignin('base', 'RegNames', RegNames);
        assignin('base', 'btnType', btnType);
        
        options.evalCode = true;
        options.showCode = false;
        options.outputDir = 'html';
    %     options.stylesheet = 'mxdom2simplehtml.xsl';
        options.codeToEvaluate = 'plot_contrasts_stmod2coc(cont_sim, pp, post_sim1, title, combinedRegions, RegNames, btnType)';
        clear ans
        ans = publish('plot_contrasts_stmod2coc.m', options);
        close(gcf)
        %web(ans, '-new');
        %web(ans, '-browser')
        winopen(ans);    
    end
end
