function varargout = fcInput(varargin)
% FCINPUT M-file for fcInput.fig
%      FCINPUT by itself, creates a new FCINPUT or raises the
%      existing singleton*.
%
%      H = FCINPUT returns the handle to a new FCINPUT or the handle to
%      the existing singleton*.
%
%      FCINPUT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FCINPUT.M with the given input arguments.
%
%      FCINPUT('Property','Value',...) creates a new FCINPUT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before fcInput_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to fcInput_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help fcInput

% Last Modified by GUIDE v2.5 09-Aug-2010 17:44:01
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Lijun Zhang, Ph.D                        %
% Center for Biomedical Imaging Statistics (CBIS)  %
% Dept. of Biostatistics and Bioinformatics        %
% Emory University                                 %
% Atlanta, GA, 30322                               %
% Email: l.zhang@emory.edu                         %
% http://www.sph.emory.edu/bios/CBIS/about.html    %
% Jan, 2009, Last revision: Dec. 1, 2011           %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @fcInput_OpeningFcn, ...
                   'gui_OutputFcn',  @fcInput_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before fcInput is made visible.
function fcInput_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to fcInput (see VARARGIN)

% Choose default command line output for fcInput
handles.output = 'Yes';
mainGuiInput = find(strcmp(varargin, 'BayesSpatialModelGui'));
handles.main = varargin{mainGuiInput+1};
mainHandles = guidata(handles.main);
% data_view=getappdata(handles.main, 'data_view');
global selectedRegionMap;
global AAL_template brodmann_template struct_template MNI_template;

% global rlm;
% global brodmannMap;

handles.selectedRegionMap = selectedRegionMap;
% if strcmp(handles.selectedRegionMap, 'analyze') == 1
%     %handles.map = rlm;
%     handles.region_struct = load_nii('anatomical\ROI_MNI_V4.hdr');   
%      
% else
%     %handles.map = brodmannMap;
%     handles.region_struct = load_nii('anatomical\brodmnn_MNI_2mm.nii');
% end

switch(handles.selectedRegionMap)
    case 'analyze'
        handles.region_struct = load_nii(fullfile('anatomical', AAL_template));         
    case 'brodmann'
        handles.region_struct = load_nii(fullfile('anatomical',brodmann_template));
    otherwise
end
handles.brain_struct = load(fullfile('anatomical', struct_template));    

opcityStep(1)= 1/10;
opcityStep(2)= 1/5;
set(handles.opacityThres, 'Min',0,'Max',1,...
'SliderStep',opcityStep, 'Value',0.5);
set(handles.opacityVal, 'String', '0.5');

thresStep(1)= 1/10;
thresStep(2)= 1/5;
set(handles.connectionThres, 'Min',0,'Max',1,...
'SliderStep',thresStep, 'Value',0.3);
set(handles.connectionVal, 'String', '0.3');

handles.conn_matrix = mainHandles.conn_matrix;
handles.singleRegions = mainHandles.singleRegions;
handles.combinedRegions = mainHandles.combinedRegions;

handles.rowRgnsName = mainHandles.rowRgnsName;
handles.colRgnsName = mainHandles.colRgnsName;

handles.rowRgns = mainHandles.rowRgns;
handles.totalRegions = mainHandles.totalRegions;

handles.totalRgnId =  mainHandles.totalRgnId;
handles.totalRgnName = mainHandles.totalRgnName;

handles.combinedName = mainHandles.combinedName;
handles.combinedId = mainHandles.combinedId;

set(handles.selectedRegionsListBox, 'String', handles.totalRgnName);
set(hObject,'Color',[0 0 0]);

if isempty(mainHandles.title_legend)
    data = mainHandles.dataInfo;
    groups=unique(data{3});
    no_groups=numel(groups);

    sessions=unique(data{4});
    no_sessions=numel(sessions);

    stimuli=unique(data{5});
    no_stimuli=numel(stimuli);

    x_labels={};        % labels for the design matrix display

    for g=1:no_groups;
        for s=1:no_sessions;
            for t=1:no_stimuli;
                x_labels{g, s, t}=strcat('(', groups(g), ',', sessions(s), ',', stimuli(t),')');
                pos=sub2ind([no_sessions no_groups no_stimuli], s, g, t); 
                labels(pos)=strcat('(', groups(g), ',', sessions(s), ',', stimuli(t),')');
            end
        end;
    end;
else
    labels = mainHandles.title_legend;
end

handles.legendLabels = labels;
set(handles.groupSessionTaskListBox, 'String', labels);

set(handles.text11, 'Visible', 'off');
set(handles.playAgain, 'Visible', 'off');
set(handles.plotPanel, 'Visible', 'off');


% Update handles structure
axes(handles.connectionMovie);
axis off;

% Determine the position of the dialog - centered on the callback figure
% if available, else, centered on the screen
FigPos=get(0,'DefaultFigurePosition');
OldUnits = get(hObject, 'Units');
set(hObject, 'Units', 'pixels');
OldPos = get(hObject,'Position');
FigWidth = OldPos(3);
FigHeight = OldPos(4);
if isempty(gcbf)
    ScreenUnits=get(0,'Units');
    set(0,'Units','pixels');
    ScreenSize=get(0,'ScreenSize');
    set(0,'Units',ScreenUnits);

    FigPos(1)=1/2*(ScreenSize(3)-FigWidth);
    FigPos(2)=2/3*(ScreenSize(4)-FigHeight);
else
    GCBFOldUnits = get(gcbf,'Units');
    set(gcbf,'Units','pixels');
    GCBFPos = get(gcbf,'Position');
    set(gcbf,'Units',GCBFOldUnits);
    FigPos(1:2) = [(GCBFPos(1) + GCBFPos(3) / 2) - FigWidth / 2, ...
                   (GCBFPos(2) + GCBFPos(4) / 2) - FigHeight / 2];
end
FigPos(3:4)=[FigWidth FigHeight];
set(hObject, 'Position', FigPos);
set(hObject, 'Units', OldUnits);

guidata(hObject, handles);
% Make the GUI modal
%set(handles.figure1,'WindowStyle','modal')

% UIWAIT makes fcInput wait for user response (see UIRESUME)
%uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = fcInput_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
% varargout{1} = handles.output;

% The figure can be deleted now
% delete(handles.figure1);



% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if isequal(get(handles.figure1, 'waitstatus'), 'waiting')
    % The GUI is still in UIWAIT, us UIRESUME
    uiresume(handles.figure1);
else
    % The GUI is no longer waiting, just close it
    delete(handles.figure1);
end


% --- Executes on key press over figure1 with no controls selected.
function figure1_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Check for "enter" or "escape"
if isequal(get(hObject,'CurrentKey'),'escape')
    % User said no by hitting escape
    handles.output = 'No';
    
    % Update handles structure
    guidata(hObject, handles);
    
    uiresume(handles.figure1);
end    
    
if isequal(get(hObject,'CurrentKey'),'return')
    uiresume(handles.figure1);
end    


% --- Executes on selection change in selectedRegionsListBox.
function selectedRegionsListBox_Callback(hObject, eventdata, handles)
% hObject    handle to selectedRegionsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns selectedRegionsListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from selectedRegionsListBox


% --- Executes during object creation, after setting all properties.
function selectedRegionsListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to selectedRegionsListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in displayMovie.
function displayMovie_Callback(hObject, eventdata, handles)
% rlm=load('data/RegionListboxMap.mat');
% brodmannMap = load('data/brodmannRegionMap.mat');
% c = load('data/conn_matrix');

set(handles.text11, 'Visible', 'on');


conn_matrix = handles.conn_matrix;

alpha = str2double(get(handles.opacityVal, 'String'));
threshold = str2double(get(handles.connectionVal, 'String'));
thick = str2double(get(handles.linethick, 'String'));
movieName = get(handles.movieName, 'String');

selectGST = get(handles.groupSessionTaskListBox, 'Value');

vals = get(handles.selectedRegionsListBox, 'String');
indices = get(handles.selectedRegionsListBox, 'Value');
allRgnId = zeros(1, size(vals, 1));
allRgnId(indices) = indices;

region_struct = handles.region_struct;
brain_struct = handles.brain_struct;

singleRegions = handles.singleRegions;
colRgnsName = handles.colRgnsName;

combinedRegions = handles.combinedRegions;

combinedName = handles.combinedName;
combinedId = handles.combinedId;
comId = regexp(combinedId, ',','split');
comName = regexp(combinedName, ',','split');
regionIds = {};
regionNames = {};
for ii = 1:length(indices)
    if indices(ii)<= length(singleRegions)
        regionIds = vertcat(regionIds, {singleRegions{indices(ii)}});
        tempName = colRgnsName{indices(ii)};
        tempName = regexprep(tempName, '_','-');
        regionNames = vertcat(regionNames, tempName);
    else
        newId = indices(ii) - length(singleRegions);
        regionIds = vertcat(regionIds, {cell2mat(combinedRegions(newId, :))});
        tempName = combinedName{newId};
        tempName = regexprep(tempName, '_','-');

        regionNames = vertcat(regionNames, tempName);
    end
end
handles.selectedregionNames = regionNames;
handles.selectedregionIds = regionIds;

guidata(hObject, handles);

cla(handles.connectionMovie);
axes(handles.connectionMovie);    
connectivity_3D_Movie(handles.connectionMovie, conn_matrix{selectGST}, allRgnId, ... %firstColRgn,... %horzcat(handles.regions', handles.combinedRegions{:,1}), ...
        region_struct, brain_struct, regionNames, regionIds, threshold, movieName, alpha, thick);

set(handles.plotPanel, 'Visible', 'on');
set(handles.playAgain, 'Visible', 'on');

%close(handles.figure1);
 % hObject    handle to displayMovie (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on selection change in groupSessionTaskListBox.
function groupSessionTaskListBox_Callback(hObject, eventdata, handles)
% hObject    handle to groupSessionTaskListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns groupSessionTaskListBox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from groupSessionTaskListBox


% --- Executes during object creation, after setting all properties.
function groupSessionTaskListBox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to groupSessionTaskListBox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function c_input_box_Callback(hObject, eventdata, handles)
% hObject    handle to c_input_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of c_input_box as text
%        str2double(get(hObject,'String')) returns contents of c_input_box as a double


% --- Executes during object creation, after setting all properties.
function c_input_box_CreateFcn(hObject, eventdata, handles)
% hObject    handle to c_input_box (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function connectionThres_Callback(hObject, eventdata, handles)
% hObject    handle to connectionThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
NewVal = round(get(hObject, 'Value')*10)/10;
set(handles.connectionVal,'String',num2str(NewVal));

% --- Executes during object creation, after setting all properties.
function connectionThres_CreateFcn(hObject, eventdata, handles)
% hObject    handle to connectionThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function connectionVal_Callback(hObject, eventdata, handles)
% hObject    handle to connectionVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of connectionVal as text
%        str2double(get(hObject,'String')) returns contents of connectionVal as a double

NewVal = get(hObject, 'String');
set(handles.connectionThres,'Value',str2num(NewVal));

% --- Executes during object creation, after setting all properties.
function connectionVal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to connectionVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on slider movement.
function opacityThres_Callback(hObject, eventdata, handles)
% hObject    handle to opacityThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

NewVal = round(get(hObject, 'Value')*10)/10;
set(handles.opacityVal,'String', num2str(NewVal));

% --- Executes during object creation, after setting all properties.
function opacityThres_CreateFcn(hObject, eventdata, handles)
% hObject    handle to opacityThres (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function opacityVal_Callback(hObject, eventdata, handles)
% hObject    handle to opacityVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of opacityVal as text
%        str2double(get(hObject,'String')) returns contents of opacityVal as a double
NewVal = get(hObject, 'String');
set(handles.opacityThres,'Value', str2num(NewVal));

% --- Executes during object creation, after setting all properties.
function opacityVal_CreateFcn(hObject, eventdata, handles)
% hObject    handle to opacityVal (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in regionIdName.
function regionIdName_Callback(hObject, eventdata, handles)
% hObject    handle to regionIdName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of regionIdName
indices = get(handles.selectedRegionsListBox, 'Value');

if get(hObject,'Value')==0
    set(handles.selectedRegionsListBox, 'String', handles.totalRgnName);    
else
    set(handles.selectedRegionsListBox, 'String', handles.totalRgnId, 'Value', indices);
end

function linethick_Callback(hObject, eventdata, handles)
% hObject    handle to linethick (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of linethick as text
%        str2double(get(hObject,'String')) returns contents of linethick as a double


% --- Executes during object creation, after setting all properties.
function linethick_CreateFcn(hObject, eventdata, handles)
% hObject    handle to linethick (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function plotAZ_Callback(hObject, eventdata, handles)
% hObject    handle to plotAZ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plotAZ as text
%        str2double(get(hObject,'String')) returns contents of plotAZ as a double

viewAZ = str2num(get(handles.plotAZ, 'String'));
viewEL = str2num(get(handles.plotEL, 'String'));
set(handles.connectionMovie, 'view', [viewAZ, viewEL]);


% --- Executes during object creation, after setting all properties.
function plotAZ_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotAZ (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function plotEL_Callback(hObject, eventdata, handles)
% hObject    handle to plotEL (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plotEL as text
%        str2double(get(hObject,'String')) returns contents of plotEL as a double
viewAZ = str2num(get(handles.plotAZ, 'String'));
viewEL = str2num(get(handles.plotEL, 'String'));
set(handles.connectionMovie, 'view', [viewAZ, viewEL]);


% --- Executes during object creation, after setting all properties.
function plotEL_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plotEL (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in plotFC.
function plotFC_Callback(hObject, eventdata, handles)
% hObject    handle to plotFC (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

conn_matrix = handles.conn_matrix;

alpha = str2double(get(handles.opacityVal, 'String'));
threshold = str2double(get(handles.connectionVal, 'String'));
thick = str2double(get(handles.linethick, 'String'));
selectGST = get(handles.groupSessionTaskListBox, 'Value');


vals = get(handles.selectedRegionsListBox, 'String');
indices = get(handles.selectedRegionsListBox, 'Value');
allRgnId = zeros(1, size(vals, 1));
allRgnId(indices) = indices;

region_struct = handles.region_struct;
brain_struct = handles.brain_struct;

regionNames = handles.selectedregionNames;
regionIds = handles.selectedregionIds;

viewAZ = str2num(get(handles.plotAZ, 'String'));
viewEL = str2num(get(handles.plotEL, 'String'));

newfig = figure;
set(newfig, 'Color', 'w');
% box on;
connectivity_3D_plot(conn_matrix{selectGST}, allRgnId, ... 
        brain_struct, region_struct, regionNames, regionIds, threshold, ...
        alpha, thick, viewAZ, viewEL);


    
% --- Executes on button press in playAgain.
function playAgain_Callback(hObject, eventdata, handles)
% hObject    handle to playAgain (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
save_path = fullfile('results','FunctionConnectionMovie');
movie_name=get(handles.movieName, 'String');
load(fullfile(save_path, [movie_name '.mat']))

% axes(handles.connectionMovie)
% for i=1:length(movFrame) 
%    view(20*i+45,25) % rotate figure 
%    % add axis label, legends, titles, etc. in here 
%    getframe(handles.connectionMovie);
%    %mov = addframe(mov,A(:,i));
% end 
movie(handles.connectionMovie, movFrame);

function movieName_Callback(hObject, eventdata, handles)
% hObject    handle to movieName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of movieName as text
%        str2double(get(hObject,'String')) returns contents of movieName as a double


% --- Executes during object creation, after setting all properties.
function movieName_CreateFcn(hObject, eventdata, handles)
% hObject    handle to movieName (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
